''2007
''1945 Shooter Game
''programming by: dreamerman
''for full credits look into 'readme.txt'



''include block

#Include "fbgfx.bi"
#Include "file.bi"
#Include "SDL\SDL.bi"
#Include "SDL\SDL_mixer.bi"


''variable declaration block

Dim shared As UInteger FPS_juz, FPS_obliczone, Czas_gry_glowny
Dim shared zwrocono as Integer
Dim Shared As Double czas_stary, czas_nowy, Czas_odstepu_klawisza, Czas_odstepu_wolniejszych_animacji, Czas_odstepu_dzwieku_pocisku, Czas_sprawdzania_kolizji, Czas_ostatniego_wyswietlania, Opoznienie_wyswietlania
Dim Shared As UByte current_screen, back_screen
Dim Shared As Single Linia_wody, Szybkosc_wody
Dim Shared As Integer CZI1, CZI2, CZI3, CZI4, CZI5, WP
Dim shared As UByte Tryb_gry, Robic_glowne, Klawisze_oczekuja_arrows, Klawisze_oczekuja_others, Show_FPS
	''tryb gry:
	''0 - brak
	''1 - intro
	''2 - menu glowne
	''3 - menu Play Game
	''4 - menu Options
	''5 - menu Credits
	''6 - menu Scoring
	''7 - reserved \ zarezerwowane
	''8 - gra
	''9 - pauza / menu podczas gry
	''10 - wprowadzanie nazwy gracza
	
Dim Shared As UByte Predkosc_FPS, Opoznienie_sleep, Opoznienie_sleep2, Predkosc_FPS_testowane	'' -> desired FPS
Dim Shared As UByte Typ_kolizji, Typ_kolizji_testowane, Czest_kolizji, Czest_kolizji_testowane	'' -> collision type 0 - simple, 1 -perpixel
Dim Shared As Single Opoznienie_kolizji

Dim Shared As Byte Pozycja_w_menu
Dim Shared As UByte Licznik_wysp, Moc_strzalu, Licznik_malych, Licznik_srednich, Licznik_duzych, Liczba_s_malych, Liczba_s_srednich, Liczba_s_duzych, Zakres_malych, Zakres_srednich, Zakres_duzych
Dim Shared As UInteger Czas_od_bazy, Zdobyte_punkty
Dim Shared As UByte Czy_jest_baza, Index_bazy, Rysowac_gracza, Dzwiek_Volume
Dim Shared As Integer Ilosc_zyc_gracza, Energia_HP_gracza, Sila_uderzenia_gracz, Sila_uderzenia_przeciwnicy

Dim Shared As UByte Pierwszy_morski_last, Pierwszy_pocisk_last, Pierwszy_powietrzny_last, Pierwszy_specjalny_last, Pierwszy_wybuch_last


Type Rect_moje
	x1 As Integer
	x2 As Integer
	y1 As Integer
	y2 As Integer
End Type

Type Point_2D
	x As Integer
	y As Integer
End Type

Type Point_2DS
	x As Single
	y As Single
End Type

Dim shared As Rect_moje Rect_wody(2), Poz_samolotu, Rect_anim_samolotu(3), Rect_ekranu, Tablica_znakow(255)
Dim Shared As UByte Woda_klatka_anim, Samolot_klatka_anim, Animacja_uszkodzenia_gracza
Dim shared As Point_2DS Kierunek_samolotu

Type Struktura_rozmieszczenia
	menu_x As UInteger
	menu_y As UInteger
	srodek_x As UInteger
	srodek_y As UInteger
	baner_duzy_x As UInteger
	baner_duzy_y As UInteger
	baner_maly_x As UInteger
	baner_maly_y As UInteger
	kraniec_wody_x As UInteger
	kraniec_wody_y As UInteger
	srodek_napisow_x As UInteger
	srodek_napisow_y As UInteger
	Ilosc_blokow_32 As UByte
	Ilosc_blokow_64 As UByte
	Ilosc_blokow_128 As UByte
	Szer As Integer
	Wys As Integer
	
End Type

Dim Shared As Struktura_rozmieszczenia Rozmieszczenie_tablica(2)
Dim Shared As UByte Index_rozdzielczosci, Index_rozdzielczosci_testowanej, Czy_pelnyekran, Czy_pelnyekran_testowane


Type Struktura_obiektu
	Pozycja_rect As Rect_moje	''pozycja obiektu, position of object
	Pozycja_point As Point_2DS	''pozycja obiektu - punkt, position of object (single variable type)
	Wielkosc As Point_2D		''wielkosc obiektu, object size
	Typ_obiektu As UByte		''typ obiektu, object type
	Kierunek_ruchu As Point_2DS	''kierunek ruchu, direction
	Wyswietlac As UByte		''czy wyswietlac, draw object?
	nr_klatki As UByte		''nr klatki animacji, current frame
	kogo_uszkadza As UByte		''kogo uszkasza - gracza, komputer
	Energia_HP As Integer		''energia HP, HP energy
	Sila As UByte					''sila obiektu, power
	Czas_od_wystrzalu As UByte	''czas ktory minal od wystrzalu, time since last shoot
	Czas_wygasniecia As UByte	''kiedy ma wygasnac, time to disapear
	
End Type

Dim shared As Struktura_obiektu Obiekty_morskie(100), Obiekty_powietrzne(100), Obiekty_pociski(200), Obiekty_wybuchy(100), Obiekty_specjalne(100)
Dim Shared As UByte Odstep_strzelania_wrogow = 3


Type Struktura_animacji
	Rect_klatki(7) As Rect_moje
	Ilosc_klatek As UByte
	Energia_HP As Integer
	Wielkosc As Point_2D
	
End Type

Dim shared As Struktura_animacji Tablica_animacji(100)


Dim Shared As UInteger Tabela_wynikow_punkty(11)
Dim Shared As String Tabela_wynikow_nazwy(11), CZS, CZS2, Nazwa_gracza



''KONIEC DEKLARACJI
''sub and function declaration
Declare Sub Petla_glowna()


Declare Function Zwroc_pierwszy_wolny_morski() As UByte
Declare Function Zwroc_pierwszy_wolny_powietrzny() As UByte
Declare Function Zwroc_pierwszy_wolny_pocisk() As UByte
Declare Function Zwroc_pierwszy_wolny_wybuch() As UByte
Declare Function Zwroc_pierwszy_wolny_specjalny() As UByte
Declare Function Podstaw_Rect_moj(x1 As UInteger, y1 As UInteger, x2 As UInteger, y2 As UInteger) As Rect_moje
Declare Function Podstaw_Point_2D(x As Integer, y As Integer) As Point_2D
Declare Function Podstaw_Point_2Ds(ByVal x As Single, ByVal y As Single) As Point_2DS


Declare Sub Wyswietl_napis_graficzny(ByVal Poz_X As Integer, ByVal Poz_Y As Integer, ByVal Tekst_do_wyswietlenia As String)
Declare Sub Uszkodz_gracza(ByVal Moc_uderzenia As Integer)
Declare Sub Dodaj_pocisk(ByVal Poz_X As Single, ByVal Poz_Y As Single, ByVal Kier_X As Single, ByVal Kier_Y As Single, ByVal Kogo_uszkadza As UByte, ByVal Typ_obiektu As UByte, ByVal Sila As Integer)
Declare Sub Dodaj_pocisk_2(ByVal Poz_X As Single, ByVal Poz_Y As Single, ByVal Poz_cal_X As Single, ByVal Poz_cal_Y As Single)
Declare Sub Dodaj_wybuch(ByVal Poz_X As Single, ByVal Poz_Y As Single, ByVal Typ_wybuchu As UByte)
Declare Sub Posprzataj_Restart()
Declare Sub Sprawdz_kolizje()

Declare Function Sprawdz_zaawansowana_kolizje(ByVal Obiekt1_X As Integer, ByVal Obiekt1_Y As Integer, ByVal Obiekt1_typ As UByte, ByVal Obiekt2_X As integer, ByVal Obiekt2_Y As integer, ByVal Obiekt2_typ As UByte, ByRef MK_X As Integer, ByRef MK_Y As Integer) As UByte
Declare Sub Procedura_dodawania_przeciwnikow()
Declare Sub Wczytaj_Dane_Animacji()
Declare Sub Dodaj_bonusa(ByVal Poz_x As Single, ByVal Poz_y As Single)
Declare Function Wybierz_pozycje_dla_wodnego(ByVal typ_obiektu As UByte) As Point_2DS


''KONIEC SUB-OW

''START
Robic_glowne = 1

Randomize Timer


''wczytanie ustawien
If (FileExists("settings.dat") = -1) Then
	WP = FreeFile
	Open "settings.dat" For Input As #WP
		Input #WP, CZS
		Index_rozdzielczosci = CUByte(CZS)
		Input #WP, CZS
		Czy_pelnyekran = CUByte(CZS)
		Input #WP, CZS
		''volume
		Dzwiek_Volume = CUByte(CZS)
		Input #WP, CZS
		Predkosc_FPS = CUByte(CZS)
		Input #WP, CZS
		Typ_kolizji = CUByte(CZS)
		Input #WP, CZS
		Czest_kolizji = CUByte(CZS)
	Close #WP
	
	''choosing proper graphic mode
	If (Czy_pelnyekran = 1) Then
		If (Index_rozdzielczosci = 2) Then Screen 18, 32, 2, &h01	''640x480
		If (Index_rozdzielczosci = 1) Then Screen 16, 32, 2, &h01	''512x384
	Else
		If (Index_rozdzielczosci = 2) Then Screen 18, 32, 2, &h00	''640x480
		If (Index_rozdzielczosci = 1) Then Screen 16, 32, 2, &h00	''512x384
	EndIf
	''end
	If (Index_rozdzielczosci = 1) Then
		With Rect_ekranu
			.x1 = 0
			.x2 = 512
			.y1 = 0
			.y2 = 384
		End With
	ElseIf (Index_rozdzielczosci = 2) Then
		With Rect_ekranu
			.x1 = 0
			.x2 = 640
			.y1 = 0
			.y2 = 480
		End With
	EndIf
Else
	Print "Settings file not found!"
	Robic_glowne = 0
	Sleep 1000

EndIf
WindowTitle "1945 Shooter Game"

/'
Screen 15, 32, 2, &h00	''400x300
With Rect_ekranu
	.x1 = 0
	.x2 = 400
	.y1 = 0
	.y2 = 300
End With
Index_rozdzielczosci = 0
'/

''Screen 14, 32, 2, &h00	''320x240
current_screen = 0: back_screen = 1 
czas_gry_glowny = 0
Show_FPS = 0
Opoznienie_sleep = CUByte(1000 / Predkosc_FPS)
Predkosc_FPS_testowane = Predkosc_FPS
If (InStr(1, Command(1), "fps") > 0) Then Show_FPS = 1
Typ_kolizji_testowane = Typ_kolizji
Czest_kolizji_testowane = Czest_kolizji
Opoznienie_kolizji = (Czest_kolizji / 1000)
Opoznienie_wyswietlania = CDbl(1) / CDbl(Predkosc_FPS)
Opoznienie_sleep2 = CUByte(Opoznienie_sleep / 4)

''how much damage is made i collision
Sila_uderzenia_gracz = 40	''of player
Sila_uderzenia_przeciwnicy = 50 ''of enemies
If (Dzwiek_Volume <0) Or (Dzwiek_Volume>128) Then Dzwiek_Volume = 128	''check


Select Case Index_rozdzielczosci
	Case 0
		Locate 18, 16: Print "Loading... Please wait."	
	Case 1
		Locate 12, 22: Print "Loading... Please wait."	
	Case 2
		Locate 15, 30: Print "Loading... Please wait."	
End Select
''Sleep 1000


''Dim Grafika_bmp as any ptr = imagecreate(1024, 768, rgb(255,255,255), 32)
Dim Shared Grafika_bmp as any ptr
Grafika_bmp = imagecreate(1024, 768, rgb(255,255,255), 32)
''zwrocono = bload("1945_24.bmp", Grafika_bmp)
zwrocono = bload("plik.bmp", Grafika_bmp)


Dim Shared As UByte Tablica_kolizji(1023, 767)
''creating table from bitmap for collision checking
For CZI1 = 0 To 1023
	For CZI2 = 0 To 767
		If (Point(CZI1, CZI2, Grafika_bmp) = 4294902015) Then
			Tablica_kolizji(CZI1, CZI2) = 0	''transparent
		Else
			Tablica_kolizji(CZI1, CZI2) = 1	''solid
		EndIf
	Next CZI2
Next CZI1


''dla wody
With Rect_wody(0)
	.x1 = 268
	.x2 = 299
	.y1 = 367
	.y2 = 398
End With 

With Rect_wody(1)
	.x1 = 301
	.x2 = 332
	.y1 = 367
	.y2 = 398
End With

Linia_wody = -32
Woda_klatka_anim = 0
Szybkosc_wody = (32 / 25)	''wysokosc bmp wody prze docelowe FPS
''koniec dla wody


''ustawianie rozmieszczenia
With Rozmieszczenie_tablica(0)	''dla 400x300
	.menu_x = (400 - 102) / 2
	.menu_y = (300 - 94) / 2
	.srodek_x = 400 / 2
	.srodek_y = 300 / 2
	.baner_duzy_x = (400 - 279) / 2
	.baner_duzy_y = (300 - 142) / 2
	.baner_maly_x = (400 - 116) / 2
	.baner_maly_y = (300 - 59) / 2 - (300 / 3.5)
	.kraniec_wody_x = 400 / 32 + 1
	.kraniec_wody_y = 300 / 32 + 2
	.Ilosc_blokow_32 = 10
	.Ilosc_blokow_64 = 4
	.Ilosc_blokow_128 = 2
	.Szer = 400
	.Wys = 300
End With

With Rozmieszczenie_tablica(1)	''dla 512x384
	.menu_x = (512 - 102) / 2
	.menu_y = (384 - 94) / 2
	.srodek_x = 512 / 2
	.srodek_y = 384 / 2
	.baner_duzy_x = (512 - 279) / 2
	.baner_duzy_y = (384 - 142) / 2
	.baner_maly_x = (512 - 116) / 2
	.baner_maly_y = (384 - 59) / 2 - (384 / 3.5)
	.kraniec_wody_x = 512 / 32
	.kraniec_wody_y = 384 / 32 + 1
	.Ilosc_blokow_32 = 14
	.Ilosc_blokow_64 = 7
	.Ilosc_blokow_128 = 4
	.Szer = 512
	.Wys = 384
End With

With Rozmieszczenie_tablica(2)	''dla 640x480
	.menu_x = (640 - 102) / 2
	.menu_y = (480 - 94) / 2
	.srodek_x = 640 / 2
	.srodek_y = 480 / 2
	.baner_duzy_x = (640 - 279) / 2
	.baner_duzy_y = (480 - 142) / 2
	.baner_maly_x = (640 - 116) / 2
	.baner_maly_y = (480 - 59) / 2 - (480 / 3.5)
	.kraniec_wody_x = 640 / 32
	.kraniec_wody_y = 480 / 32 + 1
	.Ilosc_blokow_32 = 18
	.Ilosc_blokow_64 = 9
	.Ilosc_blokow_128 = 4
	.Szer = 640
	.Wys = 480
End With
''koniec rozmieszczenia


''dla samolotu

With Poz_samolotu
	.x1 = Rect_ekranu.x2 / 2 -32
	.x2 = 319
	.y1 = Rect_ekranu.y2 / 2 + 100
	.y2 = 343
End With

With Rect_anim_samolotu(0)
	.x1 = 301
	.x2 = 365
	.y1 = 112
	.y2 = 162
End With

With Rect_anim_samolotu(1)
	.x1 = 301
	.x2 = 365
	.y1 = 178
	.y2 = 228
End With

With Rect_anim_samolotu(2)
	.x1 = 301
	.x2 = 365
	.y1 = 244
	.y2 = 294
End With

''dodatkowa klatka dla efektu migagania
With Rect_anim_samolotu(3)
	.x1 = 701
	.x2 = 765
	.y1 = 244
	.y2 = 294
End With


With Tablica_animacji(90)
	.Rect_klatki(1) = Rect_anim_samolotu(0)
	.Ilosc_klatek = 2
	.Wielkosc = Podstaw_Point_2D(64, 50)
End With


Samolot_klatka_anim = 1
Kierunek_samolotu.x = 2
Kierunek_samolotu.y = 0
''konied dla samolotu

''animacje dla obiektow
''data for object's -> rect for animation, HP and other
Wczytaj_Dane_Animacji()



''dane dla znakow
''rect data for fonts
Tablica_znakow(0) = Podstaw_Rect_moj(0, 0, 1, 1)
Tablica_znakow(32) = Podstaw_Rect_moj(0, 0, 10, 1)	'' - spacja
Tablica_znakow(33) = Podstaw_Rect_moj(714, 521, 720, 533)	''! - wykrzyknik
Tablica_znakow(46) = Podstaw_Rect_moj(709, 521, 713, 533)	''. - kropka
Tablica_znakow(48) = Podstaw_Rect_moj(580, 107, 589, 119)	''0
Tablica_znakow(49) = Podstaw_Rect_moj(590, 107, 599, 119)	''1
Tablica_znakow(50) = Podstaw_Rect_moj(600, 107, 609, 119)	''2
Tablica_znakow(51) = Podstaw_Rect_moj(610, 107, 620, 119)	''3
Tablica_znakow(52) = Podstaw_Rect_moj(621, 107, 631, 119)	''4
Tablica_znakow(53) = Podstaw_Rect_moj(632, 107, 641, 119)	''5
Tablica_znakow(54) = Podstaw_Rect_moj(642, 107, 651, 119)	''6
Tablica_znakow(55) = Podstaw_Rect_moj(652, 107, 661, 119)	''7
Tablica_znakow(56) = Podstaw_Rect_moj(662, 107, 671, 119)	''8
Tablica_znakow(57) = Podstaw_Rect_moj(672, 107, 682, 119)	''9
Tablica_znakow(58) = Podstaw_Rect_moj(720, 521, 726, 533)	'': - dwukropek
Tablica_znakow(59) = Podstaw_Rect_moj(0, 107, 1, 119)

Tablica_znakow(65) = Podstaw_Rect_moj(415, 521, 426, 533)	''A
Tablica_znakow(66) = Podstaw_Rect_moj(427, 521, 438, 533)	''B
Tablica_znakow(67) = Podstaw_Rect_moj(439, 521, 449, 533)	''C
Tablica_znakow(68) = Podstaw_Rect_moj(450, 521, 460, 533)	''D
Tablica_znakow(69) = Podstaw_Rect_moj(462, 521, 471, 533)	''E
Tablica_znakow(70) = Podstaw_Rect_moj(472, 521, 481, 533)	''F
Tablica_znakow(71) = Podstaw_Rect_moj(482, 521, 492, 533)	''G
Tablica_znakow(72) = Podstaw_Rect_moj(494, 521, 505, 533)	''H
Tablica_znakow(73) = Podstaw_Rect_moj(507, 521, 513, 533)	''I
Tablica_znakow(74) = Podstaw_Rect_moj(514, 521, 523, 533)	''J
Tablica_znakow(75) = Podstaw_Rect_moj(524, 521, 536, 533)	''K
Tablica_znakow(76) = Podstaw_Rect_moj(537, 521, 546, 533)	''L
Tablica_znakow(77) = Podstaw_Rect_moj(547, 521, 560, 533)	''M
Tablica_znakow(78) = Podstaw_Rect_moj(561, 521, 571, 533)	''N
Tablica_znakow(79) = Podstaw_Rect_moj(572, 521, 583, 533)	''O
Tablica_znakow(80) = Podstaw_Rect_moj(584, 521, 594, 533)	''P
Tablica_znakow(81) = Podstaw_Rect_moj(596, 521, 605, 533)	''Q
Tablica_znakow(82) = Podstaw_Rect_moj(607, 521, 618, 533)	''R
Tablica_znakow(83) = Podstaw_Rect_moj(619, 521, 629, 533)	''S
Tablica_znakow(84) = Podstaw_Rect_moj(629, 521, 639, 533)	''T
Tablica_znakow(85) = Podstaw_Rect_moj(640, 521, 651, 533)	''U
Tablica_znakow(86) = Podstaw_Rect_moj(652, 521, 662, 533)	''V
Tablica_znakow(87) = Podstaw_Rect_moj(663, 521, 677, 533)	''W
Tablica_znakow(88) = Podstaw_Rect_moj(678, 521, 688, 533)	''X
Tablica_znakow(89) = Podstaw_Rect_moj(689, 521, 699, 533)	''Y
Tablica_znakow(90) = Podstaw_Rect_moj(700, 521, 709, 533)	''Z


''START of game


''preapering variable -> start values 

Tryb_gry = 1	''intro
Pozycja_w_menu = 0	''Play Game

''options value
Index_rozdzielczosci_testowanej = Index_rozdzielczosci
Czy_pelnyekran_testowane = Czy_pelnyekran

Posprzataj_Restart()



''wczytanie wynikow
''loading highscores
If (FileExists("high_scores.dat") = -1) Then
	WP = FreeFile
	Open "high_scores.dat" For Input As #WP
		For CZI1 = 1 To 10
			Input #WP, CZS
			Tabela_wynikow_nazwy(CZI1) = Str(CZS)
			Input #WP, CZS
			Tabela_wynikow_punkty(CZI1) = CUInt(CZS)
		Next CZI1
	Close #WP
Else
	Print "High Scores not found!"
	Robic_glowne = 0
	Sleep 1000
EndIf


''inicjacja SDL
''setup code from "examples\SDL\music_test2.bas"
''initializing sound
Dim audio_rate as integer
Dim audio_format as Uint16
Dim audio_channels as integer
Dim audio_buffers as integer
audio_rate = 22050
audio_format = AUDIO_S16
audio_channels = 2
audio_buffers = 4096

SDL_Init(SDL_INIT_AUDIO)

If(Mix_OpenAudio(audio_rate, audio_format, audio_channels, audio_buffers)) then
   Print "Unable to open audio!"
   Sleep 1000
   Robic_glowne = 0
EndIf
Mix_AllocateChannels(16)

''dzwieki
''preaparing waves
Dim Shared As Mix_Chunk ptr wav_silnik_samolotu, wav_strzal_gracza, wav_duzy_wybuch, wav_maly_wybuch, wav_bonus 
Dim Shared As Integer strzal_gracza_kanal
wav_silnik_samolotu = NULL
wav_strzal_gracza = NULL
wav_duzy_wybuch = NULL
wav_maly_wybuch = NULL
wav_bonus = NULL

wav_silnik_samolotu = Mix_LoadWAV("aircraft008_mod.wav")
wav_strzal_gracza = Mix_LoadWAV("battle029.wav")
wav_duzy_wybuch = Mix_LoadWAV("battle004.wav")
wav_maly_wybuch = Mix_LoadWAV("battle003.wav")
wav_bonus = Mix_LoadWAV("Item2.wav")

''set volume to SDL Mixer
Mix_Volume(-1, Dzwiek_Volume)

''main loop
Petla_glowna()


''ending
ScreenSet current_screen, current_screen   

''czyszczenie SDL
''free sound resources
Mix_FreeChunk(wav_bonus)
Mix_FreeChunk(wav_maly_wybuch)
Mix_FreeChunk(wav_duzy_wybuch)
Mix_FreeChunk(wav_strzal_gracza)
Mix_FreeChunk(wav_silnik_samolotu)

''release SDL
Mix_CloseAudio
SDL_Quit


Cls
Print "Thanks!"
Print "Powered by FreeBasic..."
Print "For details look into Readme.txt"
Sleep 1000


ImageDestroy(Grafika_bmp)


''przelaczenie trybu
Screen 0


End



''KONIEC PROGRAMU
''FUNKCJE


''main loop
Sub Petla_glowna()


While (Robic_glowne = 1)


	If (Czas_nowy - Czas_ostatniego_wyswietlania >= Opoznienie_wyswietlania) Then

	''keys
	''check to "X" press (window close)
	If InKey = Chr(255) & "k" Then Robic_glowne = 0
	
	Klawisze_oczekuja_arrows = 0
	Klawisze_oczekuja_others = 0
	
	If MultiKey(FB.SC_ESCAPE) Or MultiKey(FB.SC_ENTER) Or MultiKey(FB.SC_CONTROL) Or MultiKey(FB.SC_SPACE) Then
		Klawisze_oczekuja_others = 1
	EndIf
	
	If MultiKey(FB.SC_LEFT) Or MultiKey(FB.SC_RIGHT) Or MultiKey(FB.SC_DOWN) Or MultiKey(FB.SC_UP) Then
		Klawisze_oczekuja_arrows = 1
	EndIf

	''for 'QWERTY' letters
	CZS2 = ""
	If (Tryb_gry = 10) Then
		If MultiKey(FB.SC_Q) Then CZS2 &= "Q"
		If MultiKey(FB.SC_W) Then CZS2 &= "W"
		If MultiKey(FB.SC_E) Then CZS2 &= "E"
		If MultiKey(FB.SC_R) Then CZS2 &= "R"
		If MultiKey(FB.SC_T) Then CZS2 &= "T"
		If MultiKey(FB.SC_Y) Then CZS2 &= "Y"
		If MultiKey(FB.SC_U) Then CZS2 &= "U"
		If MultiKey(FB.SC_I) Then CZS2 &= "I"
		If MultiKey(FB.SC_O) Then CZS2 &= "O"
		If MultiKey(FB.SC_P) Then CZS2 &= "P"
		If MultiKey(FB.SC_A) Then CZS2 &= "A"
		If MultiKey(FB.SC_S) Then CZS2 &= "S"
		If MultiKey(FB.SC_D) Then CZS2 &= "D"
		If MultiKey(FB.SC_F) Then CZS2 &= "F"
		If MultiKey(FB.SC_G) Then CZS2 &= "G"
		If MultiKey(FB.SC_H) Then CZS2 &= "H"
		If MultiKey(FB.SC_J) Then CZS2 &= "J"
		If MultiKey(FB.SC_K) Then CZS2 &= "K"
		If MultiKey(FB.SC_L) Then CZS2 &= "L"
		If MultiKey(FB.SC_Z) Then CZS2 &= "Z"
		If MultiKey(FB.SC_X) Then CZS2 &= "X"
		If MultiKey(FB.SC_C) Then CZS2 &= "C"
		If MultiKey(FB.SC_V) Then CZS2 &= "V"
		If MultiKey(FB.SC_B) Then CZS2 &= "B"
		If MultiKey(FB.SC_N) Then CZS2 &= "N"
		If MultiKey(FB.SC_M) Then CZS2 &= "M"
		If MultiKey(FB.SC_1) Then CZS2 &= "1"
		If MultiKey(FB.SC_2) Then CZS2 &= "2"
		If MultiKey(FB.SC_3) Then CZS2 &= "3"
		If MultiKey(FB.SC_4) Then CZS2 &= "4"
		If MultiKey(FB.SC_5) Then CZS2 &= "5"
		If MultiKey(FB.SC_6) Then CZS2 &= "6"
		If MultiKey(FB.SC_7) Then CZS2 &= "7"
		If MultiKey(FB.SC_8) Then CZS2 &= "8"
		If MultiKey(FB.SC_9) Then CZS2 &= "9"
		If MultiKey(FB.SC_0) Then CZS2 &= "0"
		If MultiKey(FB.SC_SPACE) Then CZS2 &= " "
		If MultiKey(FB.SC_BACKSPACE) Then CZS2 = "?"
		
		If (CZS2 <> "") Then Klawisze_oczekuja_others = 1 
	EndIf


   ''moving water line - animate water
	Linia_wody += Szybkosc_wody	''przesuwanie wody - tla
	If (Linia_wody >= -32) Then Linia_wody  -= 32

	
	''selection
	Select Case As Const Tryb_gry
		Case 0
			Print "error!"
			''You should not see this
		Case 1	''splash / intro
			Cls
			Put (Rozmieszczenie_tablica(Index_rozdzielczosci).baner_duzy_x, Rozmieszczenie_tablica(Index_rozdzielczosci).baner_duzy_y), Grafika_bmp, (102, 576) - (379, 716), PSet
			''150 -> 170

			''tekst
			Select Case Index_rozdzielczosci
				Case 0
					Locate 21, 16: Print "Classic 194x Game Clone."	
				Case 1
					Locate 22, 21: Print "Classic 194x Game Clone."	
				Case 2
					Locate 26, 28: Print "Classic 194x Game Clone."	
			End Select
			
			
		Case 2	''main menu
			''klawisze
			If (Klawisze_oczekuja_arrows = 1) Or (Klawisze_oczekuja_others = 1) Then
				If (Czas_nowy - Czas_odstepu_klawisza > 0.175) Then
					If MultiKey(FB.SC_ESCAPE) Then Robic_glowne = 0
					
					If MultiKey(FB.SC_DOWN) Then Pozycja_w_menu += 1
					If MultiKey(FB.SC_UP) Then Pozycja_w_menu -= 1
					
					If (Pozycja_w_menu = -1) Then Pozycja_w_menu = 4
					If (Pozycja_w_menu = 5) Then Pozycja_w_menu = 0			
					
					If MultiKey(FB.SC_ENTER) Or MultiKey(FB.SC_CONTROL) Or MultiKey(FB.SC_SPACE) Then
						If (Pozycja_w_menu = 0) Then Tryb_gry = 3
						If (Pozycja_w_menu = 1) Then Tryb_gry = 4
						If (Pozycja_w_menu = 2) Then Tryb_gry = 5
						If (Pozycja_w_menu = 3) Then Tryb_gry = 6
						If (Pozycja_w_menu = 4) Then Robic_glowne = 0					
					EndIf
					
					Czas_odstepu_klawisza = Czas_nowy
				EndIf
			EndIf
			
			''stale ustalenie pozycji Y samolotu gracza
			Poz_samolotu.y1 = Rect_ekranu.y2 / 2 + Rect_ekranu.y2 / 4
			
			''woda
			For CZI1 = 1 To Rozmieszczenie_tablica(Index_rozdzielczosci).kraniec_wody_x
				For CZI2 = 1 To Rozmieszczenie_tablica(Index_rozdzielczosci).kraniec_wody_y
					Put (CZI1 * 32 - 32, Linia_wody + (CZI2 * 32)), Grafika_bmp, (Rect_wody(Woda_klatka_anim).x1, Rect_wody(Woda_klatka_anim).y1) - (Rect_wody(Woda_klatka_anim).x2, Rect_wody(Woda_klatka_anim).y2), PSet			
				Next CZI2	
			Next CZI1
			''1945 baner
			Put (Rozmieszczenie_tablica(Index_rozdzielczosci).baner_maly_x, Rozmieszczenie_tablica(Index_rozdzielczosci).baner_maly_y), Grafika_bmp, (703, 404) - (817, 461), PSet			
			''menu
			Line (Rozmieszczenie_tablica(Index_rozdzielczosci).menu_x - 1, Rozmieszczenie_tablica(Index_rozdzielczosci).menu_y - 1) - (Rozmieszczenie_tablica(Index_rozdzielczosci).menu_x + 101, Rozmieszczenie_tablica(Index_rozdzielczosci).menu_y + 95), RGB(255, 231, 0), BF
			Put (Rozmieszczenie_tablica(Index_rozdzielczosci).menu_x, Rozmieszczenie_tablica(Index_rozdzielczosci).menu_y), Grafika_bmp, (578, 384) - (678, 478), Trans
			''samolot, aircraft
			Put (Poz_samolotu.x1, Poz_samolotu.y1), Grafika_bmp, (Rect_anim_samolotu(Samolot_klatka_anim).x1, Rect_anim_samolotu(Samolot_klatka_anim).y1) - (Rect_anim_samolotu(Samolot_klatka_anim).x2, Rect_anim_samolotu(Samolot_klatka_anim).y2), Trans
			
			
			Samolot_klatka_anim = (Samolot_klatka_anim + 1) Mod 3
			Poz_samolotu.x1 += Kierunek_samolotu.x
			If (Poz_samolotu.x1 > Rect_ekranu.x2 - 100 - 64) And (Kierunek_samolotu.x > 0) Then Kierunek_samolotu.x = -Kierunek_samolotu.x
			If (Poz_samolotu.x1 < Rect_ekranu.x1 + 100) And (Kierunek_samolotu.x < 0) Then Kierunek_samolotu.x = -Kierunek_samolotu.x
			
			''tekst graficznie
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 125, Rect_ekranu.y2 - 30, "CLASSIC 194X GAME CLONE")
			
			''wskaznik w menu, menu pointer
			Put (Rozmieszczenie_tablica(Index_rozdzielczosci).menu_x - 12, Rozmieszczenie_tablica(Index_rozdzielczosci).menu_y + 6 + (Pozycja_w_menu * 18.25)), Grafika_bmp, (569, 390) - (576, 402), Trans			
			Put (Rozmieszczenie_tablica(Index_rozdzielczosci).menu_x + 105, Rozmieszczenie_tablica(Index_rozdzielczosci).menu_y + 6 + (Pozycja_w_menu * 18.25)), Grafika_bmp, (559, 390) - (567, 402), Trans			
		
		
		Case 3	''menu Play Game

			If (Klawisze_oczekuja_others = 1) Then
				If (Czas_nowy - Czas_odstepu_klawisza > 0.175) Then
					If MultiKey(FB.SC_ENTER) Or MultiKey(FB.SC_SPACE) Then
						Tryb_gry = 8
						Zdobyte_punkty = 0
						''play sound
						Mix_PlayChannel(-1, wav_silnik_samolotu, -1)
						
						''przygotowac "get ready"
						CZI1 = Zwroc_pierwszy_wolny_specjalny()
						Obiekty_specjalne(CZI1).Pozycja_point.x = Rect_ekranu.x2 / 2 - 50
						Obiekty_specjalne(CZI1).Pozycja_point.y = Rect_ekranu.y2 / 2 - 10
						Obiekty_specjalne(CZI1).Typ_obiektu = 88
						Obiekty_specjalne(CZI1).Wyswietlac = 1
						Obiekty_specjalne(CZI1).Kierunek_ruchu.x = 0
						Obiekty_specjalne(CZI1).Kierunek_ruchu.y = 0
						Obiekty_specjalne(CZI1).Czas_wygasniecia = 4
						
					EndIf
					Czas_odstepu_klawisza = Czas_nowy
				EndIf
			EndIf
			
			Cls
			
			''wstepne informacje
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 160, Rect_ekranu.y2 / 2 - 160, "DESTROY EVERY ENEMY YOU CAN!")
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 160, Rect_ekranu.y2 / 2 - 120, "LIST OF BONUSES:")
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 140, Rect_ekranu.y2 / 2 - 80, "SHOOT POWER UP")
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 140, Rect_ekranu.y2 / 2 - 40, "REPAIR SHIELD")
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 140, Rect_ekranu.y2 / 2 + 0, "DESTROYS ALL ENEMIES ON SCREEN")
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 140, Rect_ekranu.y2 / 2 + 40, "RESET BOSS TIME")
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 140, Rect_ekranu.y2 / 2 + 80, "EXTRA LIFE")
			
			Put (Rect_ekranu.x2 / 2 - 180, Rect_ekranu.y2 / 2 - 90), Grafika_bmp, (235, 235)-(266, 266), TRANS
			Put (Rect_ekranu.x2 / 2 - 180, Rect_ekranu.y2 / 2 - 50), Grafika_bmp, (136, 268)-(167, 299), TRANS
			Put (Rect_ekranu.x2 / 2 - 180, Rect_ekranu.y2 / 2 - 10), Grafika_bmp, (103, 268)-(134, 299), TRANS
			Put (Rect_ekranu.x2 / 2 - 180, Rect_ekranu.y2 / 2 + 30), Grafika_bmp, (169, 268)-(200, 299), TRANS
			Put (Rect_ekranu.x2 / 2 - 180, Rect_ekranu.y2 / 2 + 70), Grafika_bmp, (202, 269)-(233, 299), TRANS
			
			
			''Locate 23, 20:Print "Press Enter to START"
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 100, Rect_ekranu.y2 - 50, "PRESS ENTER TO START!")
		

		Case 4	''options
			If (Klawisze_oczekuja_arrows = 1) Or (Klawisze_oczekuja_others = 1) Then
				If (Czas_nowy - Czas_odstepu_klawisza > 0.175) Then
					If MultiKey(FB.SC_ESCAPE) Then
						''powrot do menu glownego
						Index_rozdzielczosci_testowanej = Index_rozdzielczosci
						Czy_pelnyekran_testowane = Czy_pelnyekran
						Pozycja_w_menu = 0
						Tryb_gry = 2
					EndIf
					
					If MultiKey(FB.SC_ENTER) Or MultiKey(FB.SC_SPACE) Then
						''Tryb_gry = 2	''powrot do menu
						''resolution
						If (Pozycja_w_menu = 0) Then 
							Index_rozdzielczosci_testowanej += 1
							If (Index_rozdzielczosci_testowanej >= 3) Then Index_rozdzielczosci_testowanej = 1
						EndIf
						''fullscreen
						If (Pozycja_w_menu = 1) Then Czy_pelnyekran_testowane = (Czy_pelnyekran_testowane + 1) Mod 2
						''desired FPS
						If (Pozycja_w_menu = 2) Then
							If (Predkosc_FPS_testowane = 50) Then
								Predkosc_FPS_testowane = 33
							Else
								Predkosc_FPS_testowane = 50
							EndIf
						EndIf
						''collisons type
						If (Pozycja_w_menu = 3) Then
							Typ_kolizji_testowane = (Typ_kolizji_testowane + 1) Mod 2
						EndIf
						''collions rate
						If (Pozycja_w_menu = 4) Then
							Czest_kolizji_testowane = ((Czest_kolizji_testowane + 0) Mod 50) + 10
						EndIf
						''volume
						If (Pozycja_w_menu = 5) Then
							Dzwiek_Volume += 16
							If (Dzwiek_Volume > 128) Then Dzwiek_Volume = 0
							Mix_Volume(-1, Dzwiek_Volume)
							Mix_PlayChannel(-1, wav_bonus, 0)
						EndIf
						''ACCEPT
						If (Pozycja_w_menu = 6) Then
							Index_rozdzielczosci = Index_rozdzielczosci_testowanej
							Czy_pelnyekran = Czy_pelnyekran_testowane
							Predkosc_FPS = Predkosc_FPS_testowane
							Opoznienie_sleep = CUByte(1000 / Predkosc_FPS)
							Typ_kolizji = Typ_kolizji_testowane
							Czest_kolizji = Czest_kolizji_testowane
							Opoznienie_kolizji = (Czest_kolizji / 1000)
							''zmiana trybu graficznego, change graphic mode
							Rect_ekranu.x2 = Rozmieszczenie_tablica(Index_rozdzielczosci).Szer
							Rect_ekranu.y2 = Rozmieszczenie_tablica(Index_rozdzielczosci).Wys
							If (Czy_pelnyekran = 1) Then
								''Screenres Rect_ekranu.x2, Rect_ekranu.y2, 32, 2, &h01
								If (Index_rozdzielczosci = 2) Then Screen 18, 32, 2, &h01	''640x480
								If (Index_rozdzielczosci = 1) Then Screen 16, 32, 2, &h01	''512x384
							Else
								If (Index_rozdzielczosci = 2) Then Screen 18, 32, 2, &h00	''640x480
								If (Index_rozdzielczosci = 1) Then Screen 16, 32, 2, &h00	''512x384
								''Screenres Rect_ekranu.x2, Rect_ekranu.y2, 32, 2, &h00
							EndIf
							
							''zapisanie opcji do pliku, save to file
							WP = FreeFile
							Open "settings.dat" For Output As #WP
								Print #WP, Index_rozdzielczosci
								Print #WP, Czy_pelnyekran
								Print #WP, Dzwiek_Volume
								Print #WP, Predkosc_FPS
								Print #WP, Typ_kolizji
								Print #WP, Czest_kolizji
							Close #WP
							''koniec zapisu, saving ends
							
							Pozycja_w_menu = 0
							Tryb_gry = 2
						EndIf
						''CANCEL
						If (Pozycja_w_menu = 7) Then
							Index_rozdzielczosci_testowanej = Index_rozdzielczosci
							Czy_pelnyekran_testowane = Czy_pelnyekran
							Predkosc_FPS_testowane = Predkosc_FPS
							Opoznienie_sleep = CUByte(1000 / Predkosc_FPS)
							Typ_kolizji_testowane = Typ_kolizji
							Czest_kolizji_testowane = Czest_kolizji
							Opoznienie_kolizji = (Czest_kolizji / 1000)
							Pozycja_w_menu = 0
							Tryb_gry = 2
						EndIf
						
					EndIf
					
					If MultiKey(FB.SC_DOWN) Then Pozycja_w_menu += 1
					If MultiKey(FB.SC_UP) Then Pozycja_w_menu -= 1
					
					If (Pozycja_w_menu = -1) Then Pozycja_w_menu = 7
					If (Pozycja_w_menu = 8) Then Pozycja_w_menu = 0			
	
					Czas_odstepu_klawisza = Czas_nowy
				EndIf
			EndIf
			
			Cls
			
			
			''rozdzielczosc, resolution
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 150, 80, "RESOLUTION: ")
			Select Case Index_rozdzielczosci_testowanej
				Case 0
					''400x300 -> not used
					Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 + 40, 80, "400 X 300")
				Case 1
					''512x384
					Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 + 40, 80, "512 X 384")
				Case 2
					''640x480
					Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 + 40, 80, "640 X 480")
			End Select
			
			''tryb okienkowy, windowed mode?
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 150, 110, "FULL SCREEN: ")
			If (Czy_pelnyekran_testowane = 1) Then
				Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 + 40, 110, "YES")
			Else
				Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 + 40, 110, "NO")
			EndIf
			
			''how much FPS
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 150, 140, "DESIRED FPS:")
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 + 40, 140, Str(Predkosc_FPS_testowane))
			
			''per-pixel collisions
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 150, 170, "COLLISIONS TYPE:")
			If (Typ_kolizji_testowane = 0) Then
				Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 + 40, 170, "SIMPLE")			
			Else
				Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 + 40, 170, "PER PIXEL")			
			EndIf
			
			
			''how often chceck for collisons
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 150, 200, "COLLISIONS RATE:")
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 + 40, 200, Str(Czest_kolizji_testowane) & " PS")
			
			''volume
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 150, 230, "VOLUME: ")
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 + 40, 230, Str(Dzwiek_Volume))
			
			''ok
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 25, 260, "ACCEPT")
			''anuluj
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 25, 290, "CANCEL")
			
			''wsazniki menu
			Put (Rect_ekranu.x2 / 2 - 162, 80 + (Pozycja_w_menu *  30)), Grafika_bmp, (569, 390) - (576, 402), Trans			
			Put (Rect_ekranu.x2 / 2 + 162, 80 + (Pozycja_w_menu * 30)), Grafika_bmp, (559, 390) - (567, 402), Trans			
		
		Case 5	''credits

			If (Klawisze_oczekuja_others = 1) Then
				If (Czas_nowy - Czas_odstepu_klawisza > 0.175) Then
					If MultiKey(FB.SC_ESCAPE) Then Tryb_gry = 2
					
					If MultiKey(FB.SC_ENTER) Or MultiKey(FB.SC_SPACE) Then
						Tryb_gry = 2	''powrot do menu
					EndIf
					Czas_odstepu_klawisza = Czas_nowy
				EndIf
			EndIf
			
			Cls
			
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 180, Rect_ekranu.y2 / 2 - 120, "PROGRAMMED IN")
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 180, Rect_ekranu.y2 / 2 - 105, "                   FREEBASIC LANGUAGE")
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 180, Rect_ekranu.y2 / 2 - 70, "PROGRAMMED BY")
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 180, Rect_ekranu.y2 / 2 - 55, "                   DREAMERMAN")
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 180, Rect_ekranu.y2 / 2 - 20, "USING GRAPHIC FROM")
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 180, Rect_ekranu.y2 / 2 - 5, "                   SPRITE LIB GPL")
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 180, Rect_ekranu.y2 / 2 + 30, "USING SOUNDS FROM")
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 180, Rect_ekranu.y2 / 2 + 45, "                   WWW.GRSITES.COM")

			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 210, Rect_ekranu.y2 - 80, "TO SEE FULL CREDITS LOOK INTO README.TXT")
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 180, Rect_ekranu.y2 - 40, "PRESS ENTER TO RETURN TO MENU")
			
			
		Case 6	''scoring
			If (Klawisze_oczekuja_others = 1) Then
				If (Czas_nowy - Czas_odstepu_klawisza > 0.175) Then
					If MultiKey(FB.SC_ESCAPE) Then Tryb_gry = 2
					
					If MultiKey(FB.SC_ENTER) Or MultiKey(FB.SC_SPACE) Then
						Tryb_gry = 2	''powrot do menu
					EndIf
					Czas_odstepu_klawisza = Czas_nowy
				EndIf
			EndIf
			
			Cls
			
			Put (Rect_ekranu.x2 / 2 - 58, Rect_ekranu.y2 / 2 - 140), Grafika_bmp, (573, 126) - (688, 140), PSet
			
			''wyswietlanie hs
			For CZI1 = 1 To 10
				Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 120, Rect_ekranu.y2 / 2 - 110 + (CZI1 * 20), Tabela_wynikow_nazwy(CZI1))
				Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 + 50, Rect_ekranu.y2 / 2 - 110 + (CZI1 * 20), Str(Tabela_wynikow_punkty(CZI1)))
			Next CZI1
			
		
		Case 7	''reserved, currently not used
			''code...
			
			
		Case 8	''gra
			''klawisze
			If MultiKey(FB.SC_DOWN) Then
				If (Poz_samolotu.y1 < Rect_ekranu.y2 - 50) Then Poz_samolotu.y1 += 3				
			EndIf
			
			If MultiKey(FB.SC_UP) Then
				If (Poz_samolotu.y1 > 0) Then Poz_samolotu.y1 -= 3				
			EndIf
			
			If MultiKey(FB.SC_LEFT) Then
				If (Poz_samolotu.x1 > 0) Then Poz_samolotu.x1 -= 3
			EndIf
			
			If MultiKey(FB.SC_RIGHT) Then
				If (Poz_samolotu.x1 < Rect_ekranu.x2 - 64) Then Poz_samolotu.x1 += 3
			EndIf
			
			If MultiKey(FB.SC_PLUS) Then
				Czas_od_bazy += 2
			EndIf


			''obsluga klawiszy wymagajacych odstepu czasowego np. strzelanie
			If (Klawisze_oczekuja_others = 1) Then
				If (Czas_nowy - Czas_odstepu_klawisza > 0.33) Then	'' -> max 3 shots per second
					''pauza
					If MultiKey(FB.SC_ESCAPE) Then Tryb_gry = 9
					
					''strzelanie
					If MultiKey(FB.SC_CONTROL) Or MultiKey(FB.SC_SPACE) Then
						If (Moc_strzalu = 1) Then
							Dodaj_pocisk(Poz_samolotu.x1 + 23, Poz_samolotu.y1 - 10, 0, -4, 2, 59, 10)
						Else
							Dodaj_pocisk(Poz_samolotu.x1 + 23, Poz_samolotu.y1 - 10, 0, -4, 2, 60, 20)
							''dodatkowe pociski
							If (Moc_strzalu > 2) Then
								''po jednym po bokach
								Dodaj_pocisk(Poz_samolotu.x1 - 8, Poz_samolotu.y1 + 10, -4, 0, 2, 62, 10)
								Dodaj_pocisk(Poz_samolotu.x1 + 54, Poz_samolotu.y1 + 10, 4, 0, 2, 63, 10)
								If (Moc_strzalu > 3) Then
									''podwojny z tylu
									Dodaj_pocisk(Poz_samolotu.x1 + 23, Poz_samolotu.y1 + 36, 0, 4, 2, 61, 20)
									If (Moc_strzalu > 4) Then
										''dodatkowe 4 pociski po skosach - hardcore
										Dodaj_pocisk(Poz_samolotu.x1 - 6, Poz_samolotu.y1 - 6, -4, -4, 2, 64, 10)
										Dodaj_pocisk(Poz_samolotu.x1 + 52, Poz_samolotu.y1 - 6, 4, -4, 2, 65, 10)
										Dodaj_pocisk(Poz_samolotu.x1 - 6, Poz_samolotu.y1 + 36, -4, 4, 2, 66, 10)
										Dodaj_pocisk(Poz_samolotu.x1 + 52, Poz_samolotu.y1 + 36, 4, 4, 2, 67, 10)
									EndIf
								EndIf
							EndIf
						EndIf
						
					EndIf
					
					Czas_odstepu_klawisza = Czas_nowy
				EndIf
			EndIf

			
			''wolniejsze animacje, slower animation control -> per 0.1 sec
			''oraz dodawanie przeciwnikow
			If (Czas_nowy - Czas_odstepu_wolniejszych_animacji > 0.1) Then
				''animacja wybuchow, explosions
				For CZI1 = 1 To 100
					If (Obiekty_wybuchy(CZI1).Wyswietlac = 1) Then
						Obiekty_wybuchy(CZI1).nr_klatki += 1
						If (Obiekty_wybuchy(CZI1).nr_klatki > Tablica_animacji(Obiekty_wybuchy(CZI1).Typ_obiektu).Ilosc_klatek) Then
							Obiekty_wybuchy(CZI1).Wyswietlac = 0
						EndIf
					EndIf
				Next CZI1
				
				''animacja obiektow specjalnych, special object's
				For CZI1 = 1 To 100
					If (Obiekty_specjalne(CZI1).Wyswietlac = 1) Then
						Obiekty_specjalne(CZI1).nr_klatki = (Obiekty_specjalne(CZI1).nr_klatki) Mod Tablica_animacji(Obiekty_specjalne(CZI1).Typ_obiektu).Ilosc_klatek + 1
					EndIf
				Next CZI1
				
				''add enemies
				Procedura_dodawania_przeciwnikow()
				
				''check fo player destroyed animation
				If (Animacja_uszkodzenia_gracza > 1) Then
					Animacja_uszkodzenia_gracza -= 1
					Rysowac_gracza = Animacja_uszkodzenia_gracza Mod 2
				EndIf
				
				Czas_odstepu_wolniejszych_animacji = Czas_nowy
			EndIf
			
			
			''woda
			For CZI1 = 1 To Rozmieszczenie_tablica(Index_rozdzielczosci).kraniec_wody_x
				For CZI2 = 1 To Rozmieszczenie_tablica(Index_rozdzielczosci).kraniec_wody_y
					Put (CZI1 * 32 - 32, Linia_wody + (CZI2 * 32)), Grafika_bmp, (Rect_wody(Woda_klatka_anim).x1, Rect_wody(Woda_klatka_anim).y1) - (Rect_wody(Woda_klatka_anim).x2, Rect_wody(Woda_klatka_anim).y2), PSet			
				Next CZI2	
			Next CZI1
			
			''rysowanie i przesuwanie obiektow morskich
			For CZI1 = 1 To 100
				If (Obiekty_morskie(CZI1).Wyswietlac = 1) Then
					
					If (Obiekty_morskie(CZI1).Typ_obiektu < 56) Then
						''pierwsze obiekty morskie takie jak wyspy i dzialka
						Put (Obiekty_morskie(CZI1).Pozycja_point.x, Obiekty_morskie(CZI1).Pozycja_point.y), Grafika_bmp, (Tablica_animacji(Obiekty_morskie(CZI1).Typ_obiektu).Rect_klatki(Obiekty_morskie(CZI1).nr_klatki).x1, Tablica_animacji(Obiekty_morskie(CZI1).Typ_obiektu).Rect_klatki(Obiekty_morskie(CZI1).nr_klatki).y1) - (Tablica_animacji(Obiekty_morskie(CZI1).Typ_obiektu).Rect_klatki(Obiekty_morskie(CZI1).nr_klatki).x2, Tablica_animacji(Obiekty_morskie(CZI1).Typ_obiektu).Rect_klatki(Obiekty_morskie(CZI1).nr_klatki).y2), Trans
					EndIf
					
					''przesuwanie i kolizja dla wszystkich
					Obiekty_morskie(CZI1).Pozycja_point.x += Obiekty_morskie(CZI1).Kierunek_ruchu.x
					Obiekty_morskie(CZI1).Pozycja_point.y += Obiekty_morskie(CZI1).Kierunek_ruchu.y

					''czy wyszlo poza ekran					
					If (Obiekty_morskie(CZI1).Pozycja_point.x > Rect_ekranu.x2) Or ( Obiekty_morskie(CZI1).Pozycja_point.x < 0) Or (Obiekty_morskie(CZI1).Pozycja_point.y > Rect_ekranu.y2) Or (Obiekty_morskie(CZI1).Pozycja_point.y < -192) Then Obiekty_morskie(CZI1).Wyswietlac = 0
					
				EndIf
			Next CZI1
			
			''rysowanie morskich statkw
			For CZI1 = 1 To 100
				If (Obiekty_morskie(CZI1).Wyswietlac = 1) Then
					If (Obiekty_morskie(CZI1).Typ_obiektu > 55) Then
						''na koncu obiekty takie jak statki
						Put (Obiekty_morskie(CZI1).Pozycja_point.x, Obiekty_morskie(CZI1).Pozycja_point.y), Grafika_bmp, (Tablica_animacji(Obiekty_morskie(CZI1).Typ_obiektu).Rect_klatki(Obiekty_morskie(CZI1).nr_klatki).x1, Tablica_animacji(Obiekty_morskie(CZI1).Typ_obiektu).Rect_klatki(Obiekty_morskie(CZI1).nr_klatki).y1) - (Tablica_animacji(Obiekty_morskie(CZI1).Typ_obiektu).Rect_klatki(Obiekty_morskie(CZI1).nr_klatki).x2, Tablica_animacji(Obiekty_morskie(CZI1).Typ_obiektu).Rect_klatki(Obiekty_morskie(CZI1).nr_klatki).y2), Trans
					EndIf
				EndIf
			Next
					
			
			''rysowanie obiektow powietrznych
			For CZI1 = 1 To 100
				If (Obiekty_powietrzne(CZI1).Wyswietlac = 1) Then
					
					Obiekty_powietrzne(CZI1).Pozycja_point.x += Obiekty_powietrzne(CZI1).Kierunek_ruchu.x
					Obiekty_powietrzne(CZI1).Pozycja_point.y += Obiekty_powietrzne(CZI1).Kierunek_ruchu.y

					''czy wyszlo poza ekran					
					''If (Obiekty_powietrzne(CZI1).Pozycja_rect.x1 > Rect_ekranu.x2) Or (Obiekty_powietrzne(CZI1).Pozycja_rect.x2 < 0) Or (Obiekty_powietrzne(CZI1).Pozycja_rect.y1 > Rect_ekranu.y2) Or (Obiekty_powietrzne(CZI1).Pozycja_rect.y2 < 0) Then Obiekty_powietrzne(CZI1).Wyswietlac = 0
					If (Obiekty_powietrzne(CZI1).Pozycja_point.x > Rect_ekranu.x2) Or ( Obiekty_powietrzne(CZI1).Pozycja_point.x < -100) Or (Obiekty_powietrzne(CZI1).Pozycja_point.y > Rect_ekranu.y2 + 64) Or (Obiekty_powietrzne(CZI1).Pozycja_point.y < -100) Then Obiekty_powietrzne(CZI1).Wyswietlac = 0

					Put (Obiekty_powietrzne(CZI1).Pozycja_point.x, Obiekty_powietrzne(CZI1).Pozycja_point.y), Grafika_bmp, (Tablica_animacji(Obiekty_powietrzne(CZI1).Typ_obiektu).Rect_klatki(Obiekty_powietrzne(CZI1).nr_klatki).x1, Tablica_animacji(Obiekty_powietrzne(CZI1).Typ_obiektu).Rect_klatki(Obiekty_powietrzne(CZI1).nr_klatki).y1) - (Tablica_animacji(Obiekty_powietrzne(CZI1).Typ_obiektu).Rect_klatki(Obiekty_powietrzne(CZI1).nr_klatki).x2, Tablica_animacji(Obiekty_powietrzne(CZI1).Typ_obiektu).Rect_klatki(Obiekty_powietrzne(CZI1).nr_klatki).y2), Trans
					''animowanie samolotu
					Obiekty_powietrzne(CZI1).nr_klatki = (Obiekty_powietrzne(CZI1).nr_klatki) Mod Tablica_animacji(Obiekty_powietrzne(CZI1).Typ_obiektu).Ilosc_klatek + 1
				EndIf
			Next CZI1
						
			''obiekty specjalne
			For CZI1 = 1 To 100
				If (Obiekty_specjalne(CZI1).Wyswietlac = 1) Then
					
					Obiekty_specjalne(CZI1).Pozycja_point.x += Obiekty_specjalne(CZI1).Kierunek_ruchu.x
					Obiekty_specjalne(CZI1).Pozycja_point.y += Obiekty_specjalne(CZI1).Kierunek_ruchu.y

					Put (Obiekty_specjalne(CZI1).Pozycja_point.x, Obiekty_specjalne(CZI1).Pozycja_point.y), Grafika_bmp, (Tablica_animacji(Obiekty_specjalne(CZI1).Typ_obiektu).Rect_klatki(Obiekty_specjalne(CZI1).nr_klatki).x1, Tablica_animacji(Obiekty_specjalne(CZI1).Typ_obiektu).Rect_klatki(Obiekty_specjalne(CZI1).nr_klatki).y1) - (Tablica_animacji(Obiekty_specjalne(CZI1).Typ_obiektu).Rect_klatki(Obiekty_specjalne(CZI1).nr_klatki).x2, Tablica_animacji(Obiekty_specjalne(CZI1).Typ_obiektu).Rect_klatki(Obiekty_specjalne(CZI1).nr_klatki).y2), Trans
				EndIf
			Next CZI1
			
			''wybuchy
			For CZI1 = 1 To 100
				If (Obiekty_wybuchy(CZI1).Wyswietlac = 1) Then
					
					Obiekty_wybuchy(CZI1).Pozycja_point.x += Obiekty_wybuchy(CZI1).Kierunek_ruchu.x
					Obiekty_wybuchy(CZI1).Pozycja_point.y += Obiekty_wybuchy(CZI1).Kierunek_ruchu.y
					
					Put (Obiekty_wybuchy(CZI1).Pozycja_point.x, Obiekty_wybuchy(CZI1).Pozycja_point.y), Grafika_bmp, (Tablica_animacji(Obiekty_wybuchy(CZI1).Typ_obiektu).Rect_klatki(Obiekty_wybuchy(CZI1).nr_klatki).x1, Tablica_animacji(Obiekty_wybuchy(CZI1).Typ_obiektu).Rect_klatki(Obiekty_wybuchy(CZI1).nr_klatki).y1) - (Tablica_animacji(Obiekty_wybuchy(CZI1).Typ_obiektu).Rect_klatki(Obiekty_wybuchy(CZI1).nr_klatki).x2, Tablica_animacji(Obiekty_wybuchy(CZI1).Typ_obiektu).Rect_klatki(Obiekty_wybuchy(CZI1).nr_klatki).y2), Trans
				EndIf
			Next CZI1
						
			''rysowanie pociskow
			For CZI1 = 1 To 200
				If (Obiekty_pociski(CZI1).Wyswietlac = 1) Then
					
					Obiekty_pociski(CZI1).Pozycja_point.x += Obiekty_pociski(CZI1).Kierunek_ruchu.x
					Obiekty_pociski(CZI1).Pozycja_point.y += Obiekty_pociski(CZI1).Kierunek_ruchu.y
					
					If (Obiekty_pociski(CZI1).Pozycja_point.x > Rect_ekranu.x2) Or ( Obiekty_pociski(CZI1).Pozycja_point.x < -20) Or (Obiekty_pociski(CZI1).Pozycja_point.y > Rect_ekranu.y2) Or (Obiekty_pociski(CZI1).Pozycja_point.y < -20) Then Obiekty_pociski(CZI1).Wyswietlac = 0
					Put (Obiekty_pociski(CZI1).Pozycja_point.x, Obiekty_pociski(CZI1).Pozycja_point.y), Grafika_bmp, (Tablica_animacji(Obiekty_pociski(CZI1).Typ_obiektu).Rect_klatki(Obiekty_pociski(CZI1).nr_klatki).x1, Tablica_animacji(Obiekty_pociski(CZI1).Typ_obiektu).Rect_klatki(Obiekty_pociski(CZI1).nr_klatki).y1) - (Tablica_animacji(Obiekty_pociski(CZI1).Typ_obiektu).Rect_klatki(Obiekty_pociski(CZI1).nr_klatki).x2, Tablica_animacji(Obiekty_pociski(CZI1).Typ_obiektu).Rect_klatki(Obiekty_pociski(CZI1).nr_klatki).y2), Trans

				EndIf
			Next CZI1
			
			
			Sprawdz_kolizje()
			
			
			''samolot
			If (Rysowac_gracza = 1) Then
				Put (Poz_samolotu.x1, Poz_samolotu.y1), Grafika_bmp, (Rect_anim_samolotu(Samolot_klatka_anim).x1, Rect_anim_samolotu(Samolot_klatka_anim).y1) - (Rect_anim_samolotu(Samolot_klatka_anim).x2, Rect_anim_samolotu(Samolot_klatka_anim).y2), Trans			
				Samolot_klatka_anim = (Samolot_klatka_anim + 1) Mod 3
				''Poz_samolotu.x1 += Kierunek_samolotu.x
			EndIf

			''pasek postepu do bazy
			CZI2 = (Rozmieszczenie_tablica(Index_rozdzielczosci).srodek_x - 68) - 15	''polowa z 136
			Put (CZI2, Rect_ekranu.y2 - 20), Grafika_bmp, (369, 208) - (504, 227), Trans
			Put (CZI2 + 136, Rect_ekranu.y2 - 20), Grafika_bmp, (521, 208) - (550, 227), Trans			
			For CZI1 = 1 To Czas_od_bazy
				Put (CZI2 + 4 + CZI1, Rect_ekranu.y2 - 15), Grafika_bmp, (505, 213) - (505, 222), Pset				
			Next CZI1
			
			''zycie graficznie
			CZI2 = Rect_ekranu.y2 - 4
			For CZI1 = 1 To Ilosc_zyc_gracza
				Put (4, CZI2 - (32 * CZI1)), Grafika_bmp, (136, 202) - (167, 233), Trans
			Next
			
			''punkty graficznie
			Put (2, 20), Grafika_bmp, (573, 160) - (634, 174), Trans
			Wyswietl_napis_graficzny(2, 38, Str(Zdobyte_punkty))
			
			''energia HP
			Wyswietl_napis_graficzny(2, 64, "HP: " & Str(Energia_HP_gracza))
			
			 
		Case 9	''pauza / menu w grze
			''hm
			If (Klawisze_oczekuja_arrows = 1) Or (Klawisze_oczekuja_others = 1) Then
				If (Czas_nowy - Czas_odstepu_klawisza > 0.175) Then
					If MultiKey(FB.SC_ESCAPE) Then Tryb_gry = 8
					
					If MultiKey(FB.SC_Q) Then Robic_glowne = 0
	
	
					If MultiKey(FB.SC_DOWN) Then Pozycja_w_menu += 1
					If MultiKey(FB.SC_UP) Then Pozycja_w_menu -= 1
					
					If (Pozycja_w_menu = -1) Then Pozycja_w_menu = 1
					If (Pozycja_w_menu = 2) Then Pozycja_w_menu = 0
					
					If MultiKey(FB.SC_ENTER) Or MultiKey(FB.SC_SPACE) Then
						If (Pozycja_w_menu = 0) Then	Tryb_gry = 8	''powrot do gry
						If (Pozycja_w_menu = 1) Then
							''powrot do menu
							Tryb_gry = 2
							Posprzataj_Restart()
							''sdl stop sound
							Mix_HaltChannel(-1)
						EndIf
					EndIf
					
					Czas_odstepu_klawisza = Czas_nowy
				EndIf
			EndIf
		
			''woda, water
			For CZI1 = 1 To Rozmieszczenie_tablica(Index_rozdzielczosci).kraniec_wody_x
				For CZI2 = 1 To Rozmieszczenie_tablica(Index_rozdzielczosci).kraniec_wody_y
					Put (CZI1 * 32 - 32, Linia_wody + (CZI2 * 32)), Grafika_bmp, (Rect_wody(Woda_klatka_anim).x1, Rect_wody(Woda_klatka_anim).y1) - (Rect_wody(Woda_klatka_anim).x2, Rect_wody(Woda_klatka_anim).y2), PSet			
				Next CZI2	
			Next CZI1
			
			''linia
			Line (Rect_ekranu.x2 / 2 - 91, Rect_ekranu.y2 / 2 - 61)-(Rect_ekranu.x2 / 2 + 91, Rect_ekranu.y2 / 2 + 71), RGB(255, 231, 0), bf
			Line (Rect_ekranu.x2 / 2 - 90, Rect_ekranu.y2 / 2 - 60)-(Rect_ekranu.x2 / 2 + 90, Rect_ekranu.y2 / 2 + 70), RGB(0,0,0), bf
			''menu
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 65, Rect_ekranu.y2 / 2 - 50, "GAME PAUSED!")
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 80, Rect_ekranu.y2 / 2 + 0, "RETURN TO GAME")
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 65, Rect_ekranu.y2 / 2 + 30, "EXIT TO MENU")
			''wskazniki menu, menu pointers
			Put (Rect_ekranu.x2 / 2 - 103, Rect_ekranu.y2 / 2 + (Pozycja_w_menu * 30)), Grafika_bmp, (569, 390) - (576, 402), Trans			
			Put (Rect_ekranu.x2 / 2 + 96, Rect_ekranu.y2 / 2 + (Pozycja_w_menu * 30)), Grafika_bmp, (559, 390) - (567, 402), Trans			
			
			
			
		Case 10	''wprowadzanie nazwy gracza, player name
			''hm..
			If (Klawisze_oczekuja_others = 1) Then
				If (Czas_nowy - Czas_odstepu_klawisza > 0.175) Then
					If MultiKey(FB.SC_ENTER) Then
						For CZI1 = 1 To 10
							If (Zdobyte_punkty >= Tabela_wynikow_punkty(CZI1)) Then
								For CZI2 = 10 To CZI1 Step -1
									Tabela_wynikow_punkty(CZI2 + 1) = Tabela_wynikow_punkty(CZI2)
									Tabela_wynikow_nazwy(CZI2 + 1) = Tabela_wynikow_nazwy(CZI2)
								Next CZI2
								Tabela_wynikow_punkty(CZI1) = Zdobyte_punkty
								Tabela_wynikow_nazwy(CZI1) = Nazwa_gracza
								Exit For
							EndIf
						Next CZI1
						
						''zerowanie zmiennych
						Posprzataj_Restart()
	
						''zapisz do pliku
						WP = FreeFile
						Open "high_scores.dat" For Output As #wp
						For CZI1 = 1 To 10
							Print #WP, Tabela_wynikow_nazwy(CZI1)
							Print #WP, Tabela_wynikow_punkty(CZI1)
						Next CZI1 
						Close #WP
						Tryb_gry = 6	''przejscie do scoring
					EndIf

					''zmiana nazwy gracza
					If (CZS2 = "?") Then
						Nazwa_gracza = Mid(Nazwa_gracza, 1, Len(Nazwa_gracza) - 1)
					Else
						Nazwa_gracza &= CZS2
					EndIf
		
					If (Len(Nazwa_gracza) > 12) Then Nazwa_gracza = Mid(Nazwa_gracza, 1, 12)
					
					Czas_odstepu_klawisza = Czas_nowy
				EndIf
			EndIf
			
			
			
			Cls
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 100, Rect_ekranu.y2 / 2 - 50, "YOUR SCORE: " + Str(Zdobyte_punkty))
			
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 130, Rect_ekranu.y2 / 2 - 20, "PLEASE ENTER YOUR NAME:")
			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 80, Rect_ekranu.y2 / 2 + 10, Nazwa_gracza)


			Wyswietl_napis_graficzny(Rect_ekranu.x2 / 2 - 190, Rect_ekranu.y2 / 2 + 70, "THEN PRESS ENTER TO SEE HIGH SCORES")
		
		
	End Select
	
	
	Czas_ostatniego_wyswietlania = Czas_nowy

	If (Show_FPS = 1) Then
		Locate 1, 1
		Print "FPS: " & Str(fps_obliczone)
	EndIf


	fps_juz = fps_juz + 1        
	''co 1 sekunde
   If (czas_nowy - czas_stary) >= 1 Then
   	FPS_obliczone = FPS_juz
    	FPS_juz = 0
		czas_stary = czas_nowy
		
		Czas_gry_glowny += 1
		If (Czas_gry_glowny > 1000) Then Czas_gry_glowny = 0	''auto zerowanie czasu gry
		If (Czas_gry_glowny > 5) And (Tryb_gry = 1) Then Tryb_gry = 2: Czas_gry_glowny = 0: EndIf
		
		Woda_klatka_anim = (Woda_klatka_anim + 1) Mod 2
		
		
		If (Tryb_gry = 8) Then
			Czas_od_bazy += 2	''time to base
			
			''wygasanie obiektow specjalnych
			For CZI1 = 1 To 100
				If (Obiekty_specjalne(CZI1).Wyswietlac = 1) Then
					Obiekty_specjalne(CZI1).Czas_wygasniecia += 1
					If (Obiekty_specjalne(CZI1).Czas_wygasniecia > 5) Then
						Obiekty_specjalne(CZI1).Wyswietlac = 0	''nie wyswietlac juz bo wygaslo
						
						''if this is 'game over' object
						If (Obiekty_specjalne(CZI1).Typ_obiektu = 89) Then
							If (Zdobyte_punkty > Tabela_wynikow_punkty(10)) Then
								Tryb_gry = 10	''wpr nazwy gracza
							Else
								Tryb_gry = 6	''scoring
								Posprzataj_Restart()
							EndIf
							
						EndIf
						
					EndIf					
				EndIf
			Next CZI1
			
			
			''animacja obiektow wodnych
			For CZI1 = 1 To 100
				If (Obiekty_morskie(CZI1).Wyswietlac = 1) Then
					''wyszukiwanie wynurzajacej sie lodzi podwodje, wzoszacego sie samolotu itd
					If (Obiekty_morskie(CZI1).nr_klatki = Tablica_animacji(Obiekty_morskie(CZI1).Typ_obiektu).Ilosc_klatek) Then
						If (Obiekty_morskie(CZI1).Typ_obiektu = 57) Then
							''postawienie wynurzonej lodzi
							Obiekty_morskie(CZI1).Typ_obiektu = 56
							Obiekty_morskie(CZI1).nr_klatki = 1
							''Obiekty_morskie(CZI1).Energia_HP pozostaje takie samo
						ElseIf (Obiekty_morskie(CZI1).Typ_obiektu = 87) Then
							''postawienie bazy - fortecy powietrznej - najwiekszy samolot
							Obiekty_morskie(CZI1).Wyswietlac = 0
							CZI2 = Zwroc_pierwszy_wolny_powietrzny()
							Obiekty_powietrzne(CZI2).Pozycja_point.y = Obiekty_morskie(CZI1).Pozycja_point.y - 5
							Obiekty_powietrzne(CZI2).Pozycja_point.x = Obiekty_morskie(CZI1).Pozycja_point.x - 7
							Obiekty_powietrzne(CZI2).Typ_obiektu = 49
							Obiekty_powietrzne(CZI2).Kierunek_ruchu.y = 0
							Obiekty_powietrzne(CZI2).Kierunek_ruchu.x = 0
							Obiekty_powietrzne(CZI2).Wyswietlac = 1
							Obiekty_powietrzne(CZI2).nr_klatki = 1
							Obiekty_powietrzne(CZI2).kogo_uszkadza = 1
							Obiekty_powietrzne(CZI2).Energia_HP = Tablica_animacji(49).Energia_HP
							Obiekty_powietrzne(CZI2).Wielkosc = Tablica_animacji(49).Wielkosc
							Index_bazy = CZI2
							Czy_jest_baza = 1
						Else
							''animacja od nowa
							Obiekty_morskie(CZI1).nr_klatki = (Obiekty_morskie(CZI1).nr_klatki) Mod Tablica_animacji(Obiekty_morskie(CZI1).Typ_obiektu).Ilosc_klatek + 1												
						EndIf
					Else
						Obiekty_morskie(CZI1).nr_klatki = (Obiekty_morskie(CZI1).nr_klatki) Mod Tablica_animacji(Obiekty_morskie(CZI1).Typ_obiektu).Ilosc_klatek + 1					
					EndIf
				EndIf
			Next CZI1
			
			
			''strzelanie komputera
			''wystrzaly z pojazdow z dzialkami
			For CZI1 = 1 To 100
				''morskie
				If (Obiekty_morskie(CZI1).Wyswietlac = 1) Then
					Obiekty_morskie(CZI1).Czas_od_wystrzalu += 1
					If (Obiekty_morskie(CZI1).Czas_od_wystrzalu >= Odstep_strzelania_wrogow) Then
						Obiekty_morskie(CZI1).Czas_od_wystrzalu = 0
						Select Case Obiekty_morskie(CZI1).Typ_obiektu
							Case 56	''pojedynczy w gracza
								''Dodaj_pocisk(Obiekty_morskie(CZI1).Pozycja_point.x + 8, Obiekty_morskie(CZI1).Pozycja_point.y + 32, (Poz_samolotu.x1 - Obiekty_morskie(CZI1).Pozycja_point.x) / Rect_ekranu.x2 * 2, (Poz_samolotu.y1 - Obiekty_morskie(CZI1).Pozycja_point.y) / Rect_ekranu.y2 * 2, 1, 68, 10)
								Dodaj_pocisk_2(Obiekty_morskie(CZI1).Pozycja_point.x + 8, Obiekty_morskie(CZI1).Pozycja_point.y + 32, Obiekty_morskie(CZI1).Pozycja_point.x, Obiekty_morskie(CZI1).Pozycja_point.y)
							Case 58	''potrojny w gracza - obecnie pojedynczy
								''Dodaj_pocisk(Obiekty_morskie(CZI1).Pozycja_point.x + 8, Obiekty_morskie(CZI1).Pozycja_point.y + 32, (Poz_samolotu.x1 - Obiekty_morskie(CZI1).Pozycja_point.x) / Rect_ekranu.x2 * 2, (Poz_samolotu.y1 - Obiekty_morskie(CZI1).Pozycja_point.y) / Rect_ekranu.y2 * 2, 1, 68, 10)
								Dodaj_pocisk_2(Obiekty_morskie(CZI1).Pozycja_point.x + 8, Obiekty_morskie(CZI1).Pozycja_point.y + 32, Obiekty_morskie(CZI1).Pozycja_point.x, Obiekty_morskie(CZI1).Pozycja_point.y)
						End Select
					EndIf
				EndIf
				''powietrzne
				If (Obiekty_powietrzne(CZI1).Wyswietlac = 1) Then
					Obiekty_powietrzne(CZI1).Czas_od_wystrzalu += 1
					If (Obiekty_powietrzne(CZI1).Czas_od_wystrzalu >= Odstep_strzelania_wrogow) Then
						Obiekty_powietrzne(CZI1).Czas_od_wystrzalu = 0
						Select Case Obiekty_powietrzne(CZI1).Typ_obiektu
							Case 45	''pojedynczy w gore
								Dodaj_pocisk(Obiekty_powietrzne(CZI1).Pozycja_point.x + 20, Obiekty_powietrzne(CZI1).Pozycja_point.y, 0, -2 * Szybkosc_wody, 1, 68, 10)
							Case 46	''pojedynczy w dol
								Dodaj_pocisk(Obiekty_powietrzne(CZI1).Pozycja_point.x + 24, Obiekty_powietrzne(CZI1).Pozycja_point.y + 32, 0, 2 * Szybkosc_wody, 1, 68, 10)
							Case 47	''pojedynczy w gracza
								''Dodaj_pocisk(Obiekty_powietrzne(CZI1).Pozycja_point.x + 32, Obiekty_powietrzne(CZI1).Pozycja_point.y + 24, (Poz_samolotu.x1 - Obiekty_powietrzne(CZI1).Pozycja_point.x) / Rect_ekranu.x2 * 2, (Poz_samolotu.y1 - Obiekty_powietrzne(CZI1).Pozycja_point.y) / Rect_ekranu.y2 * 2, 1, 68, 10)
								Dodaj_pocisk_2(Obiekty_powietrzne(CZI1).Pozycja_point.x + 32, Obiekty_powietrzne(CZI1).Pozycja_point.y + 24, Obiekty_powietrzne(CZI1).Pozycja_point.x, Obiekty_powietrzne(CZI1).Pozycja_point.y)
							Case 49	''podwojny w gracza - baza
								''Dodaj_pocisk(Obiekty_powietrzne(CZI1).Pozycja_point.x + 30, Obiekty_powietrzne(CZI1).Pozycja_point.y + 40, (Poz_samolotu.x1 + 30 - Obiekty_powietrzne(CZI1).Pozycja_point.x) / Rect_ekranu.x2 * 2, (Poz_samolotu.y1 + 40 - Obiekty_powietrzne(CZI1).Pozycja_point.y) / Rect_ekranu.y2 * 2, 1, 68, 10)
								''Dodaj_pocisk(Obiekty_powietrzne(CZI1).Pozycja_point.x + 50, Obiekty_powietrzne(CZI1).Pozycja_point.y + 40, (Poz_samolotu.x1 + 50 - Obiekty_powietrzne(CZI1).Pozycja_point.x) / Rect_ekranu.x2 * 2, (Poz_samolotu.y1 + 40 - Obiekty_powietrzne(CZI1).Pozycja_point.y) / Rect_ekranu.y2 * 2, 1, 68, 10)
								Dodaj_pocisk_2(Obiekty_powietrzne(CZI1).Pozycja_point.x + 30, Obiekty_powietrzne(CZI1).Pozycja_point.y + 40, Obiekty_powietrzne(CZI1).Pozycja_point.x, Obiekty_powietrzne(CZI1).Pozycja_point.y)
								Dodaj_pocisk_2(Obiekty_powietrzne(CZI1).Pozycja_point.x + 50, Obiekty_powietrzne(CZI1).Pozycja_point.y + 40, Obiekty_powietrzne(CZI1).Pozycja_point.x, Obiekty_powietrzne(CZI1).Pozycja_point.y)
						End Select
					EndIf
				EndIf
			Next CZI1
			
			
			''dodanie nowych obiektow
			Czy_jest_baza = 0
			If (Obiekty_powietrzne(Index_bazy).Typ_obiektu = 49) And (Obiekty_powietrzne(Index_bazy).Wyswietlac = 1) Then Czy_jest_baza = 1 

			''postawienie bazy - wznoszacej sie
			If (Czas_od_bazy > 126) Then
				If (Czy_jest_baza = 0) Then					
					CZI1 = Zwroc_pierwszy_wolny_morski()
					Obiekty_morskie(CZI1).Pozycja_point.y = 32
					Obiekty_morskie(CZI1).Pozycja_point.x = 32 + Int(Rnd * Rozmieszczenie_tablica(Index_rozdzielczosci).Ilosc_blokow_64) * 64
					Obiekty_morskie(CZI1).Typ_obiektu = 87
					Obiekty_morskie(CZI1).Kierunek_ruchu.y = 0
					Obiekty_morskie(CZI1).Kierunek_ruchu.x = 0
					Obiekty_morskie(CZI1).Wyswietlac = 1
					Obiekty_morskie(CZI1).nr_klatki = 1
					Obiekty_morskie(CZI1).kogo_uszkadza = 0
					Obiekty_morskie(CZI1).Energia_HP = Tablica_animacji(87).Energia_HP
					Obiekty_morskie(CZI1).Wielkosc = Tablica_animacji(87).Wielkosc
				Else
					''zwieksz sile istniejacej bazy
					Obiekty_powietrzne(Index_bazy).Energia_HP = 2 * Obiekty_powietrzne(Index_bazy).Energia_HP
					If (Obiekty_powietrzne(Index_bazy).Energia_HP > 10000) Then Obiekty_powietrzne(Index_bazy).Energia_HP = 10000				
				EndIf
				

				''zwieksz czestosc pojawiania sie pojazdow
				''change frequency of enemy spawning
				If (Zakres_malych > 10) Then
					Zakres_malych -= 10
				Else
					Zakres_malych = 7	''small enemies up 1.0 sec -> 1 enemy per second
					Odstep_strzelania_wrogow = 2
				EndIf
				If (Zakres_srednich > 10) Then
					Zakres_srednich -= 10
				Else
					Zakres_srednich = 10	''medium enemies up to 1.0 sec
				EndIf
				If (Zakres_duzych > 30) Then
					Zakres_duzych -= 10
				Else
					Zakres_duzych = 30	''large enemiec up to 3.0 sec
				EndIf
				
				Czas_od_bazy = 1
			EndIf
			
			
		EndIf 
		''koniec if tryb_gry = 8
		
		
		
		''ustalenie ewentualnego nowego opoznienia
		''correcting Delay time to reach desired FPS
		/'
		If (FPS_obliczone < Predkosc_FPS - 2) Then
			Opoznienie_sleep -= 1
		ElseIf (FPS_obliczone > Predkosc_FPS + 1) Then
			Opoznienie_sleep += 1
		EndIf
		'/
		''new, testing
		If (FPS_obliczone < Predkosc_FPS - 2) Then
			Opoznienie_wyswietlania -= 0.001
		ElseIf (FPS_obliczone > Predkosc_FPS + 2) Then
			Opoznienie_wyswietlania += 0.001
		EndIf
		
		
   EndIf	''co sekunde
   
   
   ''linie pomocnicze, help lines
   ''Line (Rect_ekranu.x2 / 2, 0) - (Rect_ekranu.x2 / 2, Rect_ekranu.y2), RGB(255, 255, 255)
   ''Line (0, Rect_ekranu.y2 / 2) - (Rect_ekranu.x2, Rect_ekranu.y2 / 2), RGB(255, 255, 255)
   
	
	''podmiana stron graficznych
	''change graphic 'sites'
	current_screen = (current_screen + 1) Mod 2
	back_screen = (back_screen + 1) Mod 2
	ScreenSet back_screen, current_screen   

	
	EndIf


	''obliczanie FPS
	''co 1 sekunde
   czas_nowy = Timer
	
	''zwolnienie obciazenia CPU, free CPU power
	''Sleep 30 -> old
	''SDL_Delay(Opoznienie_sleep)
	SDL_Delay(Opoznienie_sleep2)
	    

Wend


End Sub



Function Zwroc_pierwszy_wolny_morski() As UByte
''get_first_free_sea_object

	Dim As UInteger CZIL1, CZIL2
	Dim As UByte Zwraca_f = 0 
	
	For CZIL1 = Pierwszy_morski_last To 100
		''If (Obiekty_morskie(CZIL1).Wyswietlac = 0) Then Zwraca_f = CZIL1: Exit For: EndIf
		If (Obiekty_morskie(CZIL1).Wyswietlac = 0) Then 
			Pierwszy_morski_last += 1
			Return CUByte(CZIL1)
		EndIf
	Next CZIL1
	
	Pierwszy_morski_last = 1
	''Return Zwraca_f
	Return 1
	
End Function


Function Zwroc_pierwszy_wolny_powietrzny() As UByte
''get_first_free_air_object

	Dim As UInteger CZIL1, CZIL2
	Dim As UByte Zwraca_f = 0 
	
	For CZIL1 = Pierwszy_powietrzny_last To 100
		''If (Obiekty_powietrzne(CZIL1).Wyswietlac = 0) Then Zwraca_f = CZIL1: Exit For: EndIf
		If (Obiekty_powietrzne(CZIL1).Wyswietlac = 0) Then
			Pierwszy_powietrzny_last += 1
			Return CUByte(CZIL1)
		EndIf
	Next CZIL1
	
	Pierwszy_powietrzny_last = 1
	Return 1
	
End Function


Function Zwroc_pierwszy_wolny_pocisk() As UByte
''get_first_free_missle_object

	Dim As UInteger CZIL1, CZIL2
	Dim As UByte Zwraca_f = 0 
	
	For CZIL1 = Pierwszy_pocisk_last To 200
		''If (Obiekty_pociski(CZIL1).Wyswietlac = 0) Then Zwraca_f = CZIL1: Exit For: EndIf
		If (Obiekty_pociski(CZIL1).Wyswietlac = 0) Then
			Pierwszy_pocisk_last += 1
			Return CUByte(CZIL1)
		EndIf
	Next CZIL1
	
	Pierwszy_pocisk_last = 1
	Return 1
	
End Function


Function Zwroc_pierwszy_wolny_wybuch() As UByte
''get_first_free_explosion_object

	Dim As UInteger CZIL1, CZIL2
	Dim As UByte Zwraca_f = 0 
	
	For CZIL1 = Pierwszy_wybuch_last To 100
		''If (Obiekty_wybuchy(CZIL1).Wyswietlac = 0) Then Zwraca_f = CZIL1: Exit For: EndIf
		If (Obiekty_wybuchy(CZIL1).Wyswietlac = 0) Then
			Pierwszy_wybuch_last += 1
			Return CUByte(CZIL1)
		EndIf
	Next CZIL1
	
	Pierwszy_wybuch_last = 1
	Return 1
	
End Function

Function Zwroc_pierwszy_wolny_specjalny() As UByte
''get_first_free_special_object

	Dim As UInteger CZIL1, CZIL2
	Dim As UByte Zwraca_f = 0 
	
	For CZIL1 = Pierwszy_specjalny_last To 100
		''If (Obiekty_specjalne(CZIL1).Wyswietlac = 0) Then Zwraca_f = CZIL1: Exit For: EndIf
		If (Obiekty_specjalne(CZIL1).Wyswietlac = 0) Then
			Pierwszy_specjalny_last += 1
			Return CUByte(CZIL1)
		EndIf
	Next CZIL1
	
	Pierwszy_specjalny_last = 1
	Return 1
	
End Function

Function Podstaw_Rect_moj(ByVal x1 As UInteger, ByVal y1 As UInteger, ByVal x2 As UInteger, ByVal y2 As UInteger) As Rect_moje
''
	Dim As Rect_moje Podstawiane_rect
	
	With Podstawiane_rect
		.x1 = x1
		.x2 = x2
		.y1 = y1
		.y2 = y2
	End With
	
	Return Podstawiane_rect
	
End Function


''make Point_2D type
Function Podstaw_Point_2D(ByVal x As Integer, ByVal y As Integer) As Point_2D
''
	Dim As Point_2D Podstawiany_punkt
	
	Podstawiany_punkt.x = x
	Podstawiany_punkt.y = y
	
	Return Podstawiany_punkt
	
End Function


''make Point_2Ds type
Function Podstaw_Point_2Ds(ByVal x As Single, ByVal y As Single) As Point_2DS
''
	Dim As Point_2DS Podstawiany_punkt
	
	Podstawiany_punkt.x = x
	Podstawiany_punkt.y = y
	
	Return Podstawiany_punkt
	
End Function


''draw graphical text
''call Wyswietl_napis_graficzny(Position_x, Position_y, Text)
''graphic file include only BIG / GRAND letters
Sub Wyswietl_napis_graficzny(ByVal Poz_X As Integer, ByVal Poz_Y As Integer, ByVal Tekst_do_wyswietlenia As String)
	
	Dim As Integer Curr_X, Curr_Y, Roznica_X
	Dim As UByte Poz_w_tekscie, Dlug_tekstu, Kod_ASC
	Dim As String Obrabiany_tekst
	
	Curr_X = Poz_X
	Curr_Y = Poz_y
	If (Len(Tekst_do_wyswietlenia) > 255) Then
		Obrabiany_tekst = Mid(Tekst_do_wyswietlenia, 1, 255)
	Else
		Obrabiany_tekst = Tekst_do_wyswietlenia
	EndIf
	Dlug_tekstu = Len(Obrabiany_tekst)
	
	''po koleji wyswietlanie znakow z tekstu
	For Poz_w_tekscie = 1 To Dlug_tekstu
		Kod_ASC = Asc(Mid(Obrabiany_tekst, Poz_w_tekscie, 1))
		If (Kod_ASC < 255) Then
			Put (Curr_X, Curr_Y), Grafika_bmp, (Tablica_znakow(Kod_ASC).x1, Tablica_znakow(Kod_ASC).y1) - (Tablica_znakow(Kod_ASC).x2, Tablica_znakow(Kod_ASC).y2), Trans
			Roznica_x = Tablica_znakow(Kod_ASC).x2 - Tablica_znakow(Kod_ASC).x1 + 1
			Curr_x += Roznica_x
		EndIf
	Next Poz_w_tekscie
	
End Sub



''make damage to player
''call Uszkodz_gracza(how_much_damage)
Sub Uszkodz_gracza(ByVal Moc_uderzenia As Integer)
Dim As UInteger CZIL1

Energia_HP_gracza -= Moc_uderzenia
If (Energia_HP_gracza <= 0) Then
	''zabito gracza
	''trzeba dodac jakas animacje nowego samolotu tzn. miganie
	Energia_HP_gracza = 100
	Ilosc_zyc_gracza -= 1
	Moc_strzalu = 1
	Animacja_uszkodzenia_gracza = 20
	If (Ilosc_zyc_gracza = 0) Then
		''gracz nie ma zyc
		''zatrzymaj dzwieki
		Mix_HaltChannel(-1)
		
		''add special object -> 'game over' text
		CZIL1 = Zwroc_pierwszy_wolny_specjalny()
		Obiekty_specjalne(CZIL1).Typ_obiektu = 89
		Obiekty_specjalne(CZIL1).Pozycja_point.x = Rect_ekranu.x2 / 2 - 50
		Obiekty_specjalne(CZIL1).Pozycja_point.y = Rect_ekranu.y2 / 2 - 20
		Obiekty_specjalne(CZIL1).Wyswietlac = 1
		Obiekty_specjalne(CZIL1).nr_klatki = 1
		Obiekty_specjalne(CZIL1).Czas_wygasniecia = 2
		Obiekty_specjalne(CZIL1).Kierunek_ruchu = Podstaw_Point_2Ds(0, 0)
		
		''Rysowac_gracza = 0	''hide player plane
		Poz_samolotu.x1 = -10000	''hide player plane
		/'
		If (Zdobyte_punkty > Tabela_wynikow_punkty(10)) Then
			Tryb_gry = 10	''wpr nazwy gracza
		Else
			Tryb_gry = 6	''scoring
			Posprzataj_Restart()
		EndIf
		'/
	EndIf
EndIf

End Sub



''add projectile / bullet
''call Dodaj_pocisk(Position_x, Position_y, Direction_x, Direction_y, who_damage, projectile_type, projectile_power)
Sub Dodaj_pocisk(ByVal Poz_X As Single, ByVal Poz_Y As Single, ByVal Kier_X As Single, ByVal Kier_Y As Single, ByVal Kogo_uszkadza As UByte, ByVal Typ_obiektu As UByte, ByVal Sila As Integer)
''add_missle/bullet

Dim As Integer CZIL1

	
CZIL1 = Zwroc_pierwszy_wolny_pocisk()
Obiekty_pociski(CZIL1).Pozycja_point.x = Poz_X
Obiekty_pociski(CZIL1).Pozycja_point.y = Poz_Y
Obiekty_pociski(CZIL1).Kierunek_ruchu.x = Kier_X
Obiekty_pociski(CZIL1).Kierunek_ruchu.y = Kier_Y
Obiekty_pociski(CZIL1).Wyswietlac = 1
Obiekty_pociski(CZIL1).nr_klatki = 1
Obiekty_pociski(CZIL1).kogo_uszkadza = Kogo_uszkadza
Obiekty_pociski(CZIL1).Typ_obiektu = Typ_obiektu
Obiekty_pociski(CZIL1).Sila = Sila


If (Czas_nowy - Czas_odstepu_dzwieku_pocisku >= 0.33) Then
	If (Typ_obiektu < 68) Then
		''pocisk gracza, wydaj dzwiek
		Mix_PlayChannel(-1, wav_strzal_gracza, 0)
	EndIf
	Czas_odstepu_dzwieku_pocisku = Czas_nowy
EndIf

''ready :)
	
End Sub


''add projectile / bullet
''call Dodaj_pocisk(Position_x, Position_y, Position_for_calculation_x, Position_for_calculation_Y)
Sub Dodaj_pocisk_2(ByVal Poz_X As Single, ByVal Poz_Y As Single, ByVal Poz_cal_X As Single, ByVal Poz_cal_Y As Single)
''add_missle/bullet, this version is used for enemies with direction to player, so direction, who_damage and others are oblivious

Dim As Integer CZIL1
Dim As Single vxl, vyl	''vector x, y local
Dim As Single CZISi1, CZISi2, CZISi3, CZISi4, CZISi5


CZIL1 = Zwroc_pierwszy_wolny_pocisk()
Obiekty_pociski(CZIL1).Pozycja_point.x = Poz_X
Obiekty_pociski(CZIL1).Pozycja_point.y = Poz_Y

''direction to player
CZISi2 = Poz_cal_X - Poz_samolotu.x1
CZISi3 = Poz_cal_Y - Poz_samolotu.y1
CZISi4 = Abs(CZISi2)
CZISi5 = Abs(CZISi3)

If (CZISi4 > CZISi5) Then
	vxl = 2	''max speed of bullet
	vyl = (CZISi5 / CZISi4) * 2
Else
	vyl = 2
	vxl = (CZISi4 / CZISi5) * 2
EndIf

If (CZISi2 > 0) Then vxl = -vxl
If (CZISi3 > 0) Then vyl = -vyl

Obiekty_pociski(CZIL1).Kierunek_ruchu.x = vxl
Obiekty_pociski(CZIL1).Kierunek_ruchu.y = vyl

Obiekty_pociski(CZIL1).Wyswietlac = 1
Obiekty_pociski(CZIL1).nr_klatki = 1
Obiekty_pociski(CZIL1).kogo_uszkadza = 1
Obiekty_pociski(CZIL1).Typ_obiektu = 68
Obiekty_pociski(CZIL1).Sila = 10

''ready :)
	
End Sub


''add explosion
''call Dodaj_wybuch(Position_x, Position_y, explosion_type)
Sub Dodaj_wybuch(ByVal Poz_X As Single, ByVal Poz_Y As Single, ByVal Typ_wybuchu As UByte)
''add_explosion

Dim As Integer CZIL1

CZIL1 = Zwroc_pierwszy_wolny_wybuch()
Obiekty_wybuchy(CZIL1).Pozycja_point.x = Poz_X
Obiekty_wybuchy(CZIL1).Pozycja_point.y = Poz_Y
Obiekty_wybuchy(CZIL1).Typ_obiektu = Typ_wybuchu
Obiekty_wybuchy(CZIL1).Kierunek_ruchu.y = Szybkosc_wody
Obiekty_wybuchy(CZIL1).Wyswietlac = 1
Obiekty_wybuchy(CZIL1).nr_klatki = 1

If (Typ_wybuchu = 71) Then
	Mix_PlayChannel(-1, wav_duzy_wybuch, 0)
Else
	Mix_PlayChannel(-1, wav_maly_wybuch, 0)
EndIf

''ready

End Sub



''add power-up
''call Dodaj_bonusa(Position_x, Position_y)
Sub Dodaj_bonusa(ByVal Poz_x As Single, ByVal Poz_y As Single)

	Dim As Integer CZIL1, CZIL2
	
	CZIL1 = Zwroc_pierwszy_wolny_specjalny()
	''CZIL2 = Int(Rnd * 5)
	If (Energia_HP_gracza < 70) Then
		CZIL2 = 3	''pancerz
	Else
		If (Moc_strzalu < 5) Then
			CZIL2 = 1	''shoot power-up
		Else
			If (Ilosc_zyc_gracza < 2) Then
				CZIL2 = 0	''zycie
			Else
				''losowanie, zniszczenie wrogow lub kasacja czasu do bazu
				CZIL2 = Int(Rnd * 2) + 2
				If (CZIL2 = 3) Then CZIL2 = 4
			EndIf
		EndIf
	EndIf
	
	If (CZIL2 < 5) Then
		Obiekty_specjalne(CZIL1).Pozycja_point = Podstaw_Point_2Ds(Poz_x, Poz_y)
		Obiekty_specjalne(CZIL1).Kierunek_ruchu.y = Szybkosc_wody
		Obiekty_specjalne(CZIL1).Typ_obiektu = 79 + CUByte(CZIL2)
		Obiekty_specjalne(CZIL1).Wyswietlac = 1
		Obiekty_specjalne(CZIL1).nr_klatki = 1
		Obiekty_specjalne(CZIL1).Czas_wygasniecia = 0
	EndIf
	
	
	
End Sub


''clear variables and other
Sub Posprzataj_Restart()
''clear_restart

''podstawowe rzeczy
Licznik_wysp = 0
Licznik_malych = 0
Licznik_srednich = 0
Licznik_duzych = 0
Liczba_s_malych = 1
Liczba_s_srednich = 1
Liczba_s_duzych = 1
Zakres_malych = 50
Zakres_srednich = 100
Zakres_duzych = 200

Moc_strzalu = 1	''podstawowa
Czas_od_bazy = 0
Czy_jest_baza = 0	''nie ma bazy
Index_bazy = 0
Ilosc_zyc_gracza = 2
Energia_HP_gracza = 100
Zdobyte_punkty = 0


Pierwszy_morski_last = 1
Pierwszy_pocisk_last = 1
Pierwszy_powietrzny_last = 1
Pierwszy_specjalny_last = 1
Pierwszy_wybuch_last = 1

Rysowac_gracza = 1	''draw player
Poz_samolotu.x1 = Rect_ekranu.x2 / 2
Odstep_strzelania_wrogow = 3
Animacja_uszkodzenia_gracza = 1


''zerowanie tablica przeciwnikow
For CZI1 = 1 To 100
	Obiekty_morskie(CZI1).Wyswietlac = 0
	Obiekty_powietrzne(CZI1).Wyswietlac = 0
	Obiekty_wybuchy(CZI1).Wyswietlac = 0
	Obiekty_specjalne(CZI1).Wyswietlac = 0
	Obiekty_pociski(CZI1).Wyswietlac = 0
Next CZI1
For CZI1 = 100 To 200
	Obiekty_pociski(CZI1).Wyswietlac = 0
Next CZI1
	
	
End Sub


''checking collisions sub
Sub Sprawdz_kolizje()


Dim As UByte CZBL1, CZBL2
Dim As Integer CZIL1, CZIL2, CZIL3
	
			''kolizja
			If (Czas_nowy - Czas_sprawdzania_kolizji >= Opoznienie_kolizji) Then
				''najpierw kolizja z graczem
				''morskie
				For CZI1 = 1 To 100
					If (obiekty_morskie(CZI1).Wyswietlac = 1) Then
						''czy jest kolizja z graczem
						If (Obiekty_morskie(CZI1).Typ_obiektu > 52) Then
							If (Obiekty_morskie(CZI1).Pozycja_point.x > Poz_samolotu.x1 - Obiekty_morskie(CZI1).Wielkosc.x) Then
								If (Obiekty_morskie(CZI1).Pozycja_point.x < Poz_samolotu.x1 + 64) Then
									If (Obiekty_morskie(CZI1).Pozycja_point.y > Poz_samolotu.y1 - Obiekty_morskie(CZI1).Wielkosc.y) Then
										If (Obiekty_morskie(CZI1).Pozycja_point.y < Poz_samolotu.y1 + 46) Then
											''nastapila kolizja
											CZBL1 = 1
											If (Typ_kolizji = 1) Then
												CZBL1 = Sprawdz_zaawansowana_kolizje(Obiekty_morskie(CZI1).Pozycja_point.x, Obiekty_morskie(CZI1).Pozycja_point.y, Obiekty_morskie(CZI1).Typ_obiektu, Poz_samolotu.x1, Poz_samolotu.y1, 90, CZIL1, CZIL2)
												CZIL1 -= 16
												CZIL2 -= 16
											Else
												CZIL1 = Obiekty_pociski(CZI1).Pozycja_point.x
												CZIL2 = Obiekty_pociski(CZI1).Pozycja_point.y
											EndIf
											
											''kolizja
											If (CZBL1 = 1) Then
												''dodaj maly wybuch w punkcie kolizji
												Dodaj_wybuch(CZIL1, CZIL2, 70)
												
												Uszkodz_gracza(Sila_uderzenia_gracz)
												Obiekty_morskie(CZI1).Energia_HP -= Sila_uderzenia_przeciwnicy
												
												If (Obiekty_morskie(CZI1).Energia_HP <= 0) Then
													''zniszczone, dodac duzy wybuch
													Obiekty_morskie(CZI1).Wyswietlac = 0
													Zdobyte_punkty += CInt(Tablica_animacji(Obiekty_morskie(CZI1).Typ_obiektu).Energia_HP)
															
													If (Obiekty_morskie(CZI1).Typ_obiektu < 56) Then
														Dodaj_wybuch(Obiekty_morskie(CZI1).Pozycja_point.x, Obiekty_morskie(CZI1).Pozycja_point.y, 70)
													Else
														Dodaj_wybuch(Obiekty_morskie(CZI1).Pozycja_point.x + ((Obiekty_morskie(CZI1).Wielkosc.x - 64) / 2), Obiekty_morskie(CZI1).Pozycja_point.y + ((Obiekty_morskie(CZI1).Wielkosc.y - 64) / 2), 71)
														''dodac jakis bonus
														Dodaj_bonusa(Obiekty_morskie(CZI1).Pozycja_point.x + ((Obiekty_morskie(CZI1).Wielkosc.x - 32) / 2), Obiekty_morskie(CZI1).Pozycja_point.y + ((Obiekty_morskie(CZI1).Wielkosc.y - 32) / 2))
													EndIf
												Else
													''dodac maly wybuch
													Dodaj_wybuch(Obiekty_morskie(CZI1).Pozycja_point.x + ((Obiekty_morskie(CZI1).Wielkosc.x - 32) / 2), Obiekty_morskie(CZI1).Pozycja_point.y + ((Obiekty_morskie(CZI1).Wielkosc.y - 32) / 2), 70)
												EndIf
												
											EndIf
											''end kolizja
											
										EndIf
									EndIf
								EndIf
							EndIf
						EndIf
					EndIf
				Next CZI1
				
				''powietrzne
				For CZI1 = 1 To 100
					If (Obiekty_powietrzne(CZI1).Wyswietlac = 1) Then
						''czy jest kolizja z graczem
						If (Obiekty_powietrzne(CZI1).Typ_obiektu < 52) Then
							If (Obiekty_powietrzne(CZI1).Pozycja_point.x > Poz_samolotu.x1 - Obiekty_powietrzne(CZI1).Wielkosc.x) Then
								If (Obiekty_powietrzne(CZI1).Pozycja_point.x < Poz_samolotu.x1 + 64) Then
									If (Obiekty_powietrzne(CZI1).Pozycja_point.y > Poz_samolotu.y1 - Obiekty_powietrzne(CZI1).Wielkosc.y) Then
										If (Obiekty_powietrzne(CZI1).Pozycja_point.y < Poz_samolotu.y1 + 46) Then
											''nastapila kolizja
											CZBL1 = 1
											If (Typ_kolizji = 1) Then
												CZBL1 = Sprawdz_zaawansowana_kolizje(Obiekty_powietrzne(CZI1).Pozycja_point.x, Obiekty_powietrzne(CZI1).Pozycja_point.y, Obiekty_powietrzne(CZI1).Typ_obiektu, Poz_samolotu.x1, Poz_samolotu.y1, 90, CZIL1, CZIL2)
												CZIL1 -= 16
												CZIL2 -= 16
											Else
												CZIL1 = Obiekty_pociski(CZI1).Pozycja_point.x
												CZIL2 = Obiekty_pociski(CZI1).Pozycja_point.y
											EndIf
											
											''kolizja
											If (CZBL1 = 1) Then
												''dodaj maly wybuch w punkcie kolizji
												Dodaj_wybuch(CZIL1, CZIL2, 70)
												
												Uszkodz_gracza(Sila_uderzenia_gracz)
												Obiekty_powietrzne(CZI1).Energia_HP -= Sila_uderzenia_przeciwnicy
														
												If (Obiekty_powietrzne(CZI1).Energia_HP <= 0) Then
													''zniszczone, dodac duzy wybuch
													Obiekty_powietrzne(CZI1).Wyswietlac = 0
													Zdobyte_punkty += CInt(Tablica_animacji(Obiekty_powietrzne(CZI1).Typ_obiektu).Energia_HP)
													
													If (Obiekty_powietrzne(CZI1).Typ_obiektu < 45) Then
														Dodaj_wybuch(Obiekty_powietrzne(CZI1).Pozycja_point.x, Obiekty_powietrzne(CZI1).Pozycja_point.y, 70)
													Else
														Dodaj_wybuch(Obiekty_powietrzne(CZI1).Pozycja_point.x + ((Obiekty_powietrzne(CZI1).Wielkosc.x - 64) / 2), Obiekty_powietrzne(CZI1).Pozycja_point.y + ((Obiekty_powietrzne(CZI1).Wielkosc.y - 64) / 2), 71)
														''dodac jakis bonus
														If (Obiekty_powietrzne(CZI1).Typ_obiektu > 46) Then
															Dodaj_bonusa(Obiekty_powietrzne(CZI1).Pozycja_point.x + ((Obiekty_powietrzne(CZI1).Wielkosc.x - 32) / 2), Obiekty_powietrzne(CZI1).Pozycja_point.y + ((Obiekty_powietrzne(CZI1).Wielkosc.y - 32) / 2))
														EndIf	''koniec IF typ > 46
													EndIf
												Else
													''dodac maly wybuch
													Dodaj_wybuch(Obiekty_powietrzne(CZI1).Pozycja_point.x + ((Obiekty_powietrzne(CZI1).Wielkosc.x - 32) / 2), Obiekty_powietrzne(CZI1).Pozycja_point.y + ((Obiekty_powietrzne(CZI1).Wielkosc.y - 32) / 2), 70)
												EndIf
												
											EndIf
											''end kolizja
											
										EndIf
									EndIf
								EndIf
							EndIf
						EndIf
					EndIf
				Next CZI1
				'/
				''obiekty specjalne
				For CZI1 = 1 To 100
					If (OBiekty_specjalne(CZI1).Wyswietlac = 1) Then
						''sprawdzic czy samolot na nie wlecial
						If (Obiekty_specjalne(CZI1).Pozycja_point.x > Poz_samolotu.x1- 32) Then
							If (Obiekty_specjalne(CZI1).Pozycja_point.x < Poz_samolotu.x1 + 64) Then
								If (Obiekty_specjalne(CZI1).Pozycja_point.y > Poz_samolotu.y1 - 32) Then
									If (Obiekty_specjalne(CZI1).Pozycja_point.y < Poz_samolotu.y1 + 50) Then
										''zlapano bonusa
										''dzwiek
										Mix_PlayChannel(-1, wav_bonus, 0)
										''reszta
										Select Case Obiekty_specjalne(CZI1).Typ_obiektu
											Case 79	''mini, dodatkowe zycie
												If (Ilosc_zyc_gracza < 5) Then Ilosc_zyc_gracza += 1
											Case 80	''power bonus
												If (Moc_strzalu < 5) Then Moc_strzalu += 1
											Case 81	''mini + 4 kolki, niszczenie wszystkich wrogow
												''zniszcz ich
												For CZI2 = 1 To 100
													''morskie
													If (Obiekty_morskie(CZI2).Wyswietlac = 1) Then
														If (Obiekty_morskie(CZI2).Typ_obiektu > 52) Then
															Obiekty_morskie(CZI2).Wyswietlac = 0
															''dodac wybuchy
	
															If (Obiekty_morskie(CZI2).Typ_obiektu < 56) Then
																Dodaj_wybuch(Obiekty_morskie(CZI2).Pozycja_point.x, Obiekty_morskie(CZI2).Pozycja_point.y, 70)
															Else
																Dodaj_wybuch(Obiekty_morskie(CZI2).Pozycja_point.x + ((Obiekty_morskie(CZI2).Wielkosc.x - 64) / 2), Obiekty_morskie(CZI2).Pozycja_point.y + ((Obiekty_morskie(CZI2).Wielkosc.y - 64) / 2), 71)
															EndIf
															
														EndIf
													EndIf
													
													''powietrzne
													If (Obiekty_powietrzne(CZI2).Wyswietlac = 1) Then
														Obiekty_powietrzne(CZI2).Wyswietlac = 0
														
															If (Obiekty_powietrzne(CZI2).Typ_obiektu < 45) Then
																Dodaj_wybuch(Obiekty_powietrzne(CZI2).Pozycja_point.x, Obiekty_powietrzne(CZI2).Pozycja_point.y, 70)
															Else
																Dodaj_wybuch(Obiekty_powietrzne(CZI2).Pozycja_point.x + ((Obiekty_powietrzne(CZI2).Wielkosc.x - 64) / 2), Obiekty_powietrzne(CZI2).Pozycja_point.y + ((Obiekty_powietrzne(CZI2).Wielkosc.y - 64) / 2), 71)
															EndIf													
													EndIf
													
												Next CZI2
											Case 82	''mini + tarcza, odnowienie energi
												Energia_HP_gracza = 100
											Case 83	''skrzydelka, czas_bazy = 0
												Czas_od_bazy = 0
										End Select
										Obiekty_specjalne(CZI1).Wyswietlac = 0
									EndIf
								EndIf
							EndIf
						EndIf
					Endif
				Next CZI1
				
				''kolizja z pociskami
				For CZI1 = 1 To 200
					If (Obiekty_pociski(CZI1).Wyswietlac = 1) Then
						If (Obiekty_pociski(CZI1).kogo_uszkadza = 2) Then
						''sprawdzenie czy trafilo na cos
							For CZI2 = 1 To 100
								
								''morskie
								If (Obiekty_morskie(CZI2).Wyswietlac = 1) Then
									If (Obiekty_morskie(CZI2).Typ_obiektu > 52) Then
										If (Obiekty_pociski(CZI1).Pozycja_point.x > Obiekty_morskie(CZI2).Pozycja_point.x - 18) Then
											If (Obiekty_pociski(CZI1).Pozycja_point.x < Obiekty_morskie(CZI2).Pozycja_point.x + Obiekty_morskie(CZI2).Wielkosc.x) Then
												If (Obiekty_pociski(CZI1).Pozycja_point.y > Obiekty_morskie(CZI2).Pozycja_point.y - 18) Then
													If (Obiekty_pociski(CZI1).Pozycja_point.y < Obiekty_morskie(CZI2).Pozycja_point.y + Obiekty_morskie(CZI2).Wielkosc.y) Then
														''kolizja
														CZBL1 = 1
														If (Typ_kolizji = 1) Then
															CZBL1 = Sprawdz_zaawansowana_kolizje(Obiekty_morskie(CZI2).Pozycja_point.x, Obiekty_morskie(CZI2).Pozycja_point.y, Obiekty_morskie(CZI2).Typ_obiektu, Obiekty_pociski(CZI1).Pozycja_point.x, Obiekty_pociski(CZI1).Pozycja_point.y, Obiekty_pociski(CZI1).Typ_obiektu, CZIL1, CZIL2)
															CZIL1 -= (Tablica_animacji(Obiekty_pociski(CZI1).Typ_obiektu).Wielkosc.x / 2)
															CZIL2 -= (Tablica_animacji(Obiekty_pociski(CZI1).Typ_obiektu).Wielkosc.y / 2)
														Else
															CZIL1 = Obiekty_pociski(CZI1).Pozycja_point.x
															CZIL2 = Obiekty_pociski(CZI1).Pozycja_point.y
														EndIf
														
														If (CZBL1 = 1) Then
															Obiekty_morskie(CZI2).Energia_HP -= CInt(Obiekty_pociski(CZI1).Sila)
															
															Obiekty_pociski(CZI1).Wyswietlac = 0
															If (Obiekty_morskie(CZI2).Energia_HP <= 0) Then
																''zniszczone, dodac wybuch
																Obiekty_morskie(CZI2).Wyswietlac = 0
																Zdobyte_punkty += CInt(Tablica_animacji(Obiekty_morskie(CZI2).Typ_obiektu).Energia_HP)
																
																If (Obiekty_morskie(CZI2).Typ_obiektu < 56) Then
																	Dodaj_wybuch(Obiekty_morskie(CZI2).Pozycja_point.x, Obiekty_morskie(CZI2).Pozycja_point.y, 70)
																Else
																	Dodaj_wybuch(Obiekty_morskie(CZI2).Pozycja_point.x + ((Obiekty_morskie(CZI2).Wielkosc.x - 64) / 2), Obiekty_morskie(CZI2).Pozycja_point.y + ((Obiekty_morskie(CZI2).Wielkosc.y - 64) / 2), 71)
																	''dodac jakis bonus
																	Dodaj_bonusa(Obiekty_morskie(CZI2).Pozycja_point.x + ((Obiekty_morskie(CZI2).Wielkosc.x - 32) / 2), Obiekty_morskie(CZI2).Pozycja_point.y + ((Obiekty_morskie(CZI2).Wielkosc.y - 32) / 2))
																EndIf
															Else
																''Dodaj_wybuch(Obiekty_pociski(CZI1).Pozycja_point.x, Obiekty_pociski(CZI1).Pozycja_point.y, 70)
																Dodaj_wybuch(CZIL1, CZIL2, 70)
															EndIf
															
														EndIf
														
														
													EndIf
												EndIf
											EndIf								
										EndIf									
									EndIf
								EndIf
								''powietrzne
								If (Obiekty_powietrzne(CZI2).Wyswietlac = 1) Then
									If (OBiekty_powietrzne(CZI2).Typ_obiektu < 52) Then
										If (Obiekty_pociski(CZI1).Pozycja_point.x > Obiekty_powietrzne(CZI2).Pozycja_point.x - 18) Then
											If (Obiekty_pociski(CZI1).Pozycja_point.x < Obiekty_powietrzne(CZI2).Pozycja_point.x + Obiekty_powietrzne(CZI2).Wielkosc.x) Then
												If (Obiekty_pociski(CZI1).Pozycja_point.y > Obiekty_powietrzne(CZI2).Pozycja_point.y - 18) Then
													If (Obiekty_pociski(CZI1).Pozycja_point.y < Obiekty_powietrzne(CZI2).Pozycja_point.y + Obiekty_powietrzne(CZI2).Wielkosc.y) Then
														''kolizja
														CZBL1 = 1
														If (Typ_kolizji = 1) Then
															CZBL1 = Sprawdz_zaawansowana_kolizje(Obiekty_powietrzne(CZI2).Pozycja_point.x, Obiekty_powietrzne(CZI2).Pozycja_point.y, Obiekty_powietrzne(CZI2).Typ_obiektu, Obiekty_pociski(CZI1).Pozycja_point.x, Obiekty_pociski(CZI1).Pozycja_point.y, Obiekty_pociski(CZI1).Typ_obiektu, CZIL1, CZIL2)
															CZIL1 -= (Tablica_animacji(Obiekty_pociski(CZI1).Typ_obiektu).Wielkosc.x / 2)
															CZIL2 -= (Tablica_animacji(Obiekty_pociski(CZI1).Typ_obiektu).Wielkosc.y / 2)
														Else
															CZIL1 = Obiekty_pociski(CZI1).Pozycja_point.x
															CZIL2 = Obiekty_pociski(CZI1).Pozycja_point.y
														EndIf
														
														''point of the collision
														''Line (CZIL1 - 20,CZIL2)-(CZIL1+20,CZIL2),RGB(255,0,0)
														''Line (CZIL1,CZIL2-20)-(CZIL1,CZIL2+20),RGB(255,0,0)

														If (CZBL1 = 1) Then
															Obiekty_powietrzne(CZI2).Energia_HP -= CInt(Obiekty_pociski(CZI1).Sila)
															
															Obiekty_pociski(CZI1).Wyswietlac = 0
															If (Obiekty_powietrzne(CZI2).Energia_HP <= 0) Then
																''zniszczone, dodac wybuch
																Obiekty_powietrzne(CZI2).Wyswietlac = 0
																Zdobyte_punkty += CInt(Tablica_animacji(Obiekty_powietrzne(CZI2).Typ_obiektu).Energia_HP)
																
																If (Obiekty_powietrzne(CZI2).Typ_obiektu < 45) Then
																	Dodaj_wybuch(Obiekty_powietrzne(CZI2).Pozycja_point.x, Obiekty_powietrzne(CZI2).Pozycja_point.y, 70)
																Else
																	Dodaj_wybuch(Obiekty_powietrzne(CZI2).Pozycja_point.x + ((Obiekty_powietrzne(CZI2).Wielkosc.x - 64) / 2), Obiekty_powietrzne(CZI2).Pozycja_point.y + ((Obiekty_powietrzne(CZI2).Wielkosc.y - 64) / 2), 71)
																	''dodac jakis bonus
																	If (Obiekty_powietrzne(CZI2).Typ_obiektu > 46) Then
																		Dodaj_bonusa(Obiekty_powietrzne(CZI2).Pozycja_point.x + ((Obiekty_powietrzne(CZI2).Wielkosc.x - 32) / 2), Obiekty_powietrzne(CZI2).Pozycja_point.y + ((Obiekty_powietrzne(CZI2).Wielkosc.y - 32) / 2))
																	EndIf
																EndIf													
															Else
																''Dodaj_wybuch(Obiekty_pociski(CZI1).Pozycja_point.x, Obiekty_pociski(CZI1).Pozycja_point.y, 70)
																Dodaj_wybuch(CZIL1, CZIL2, 70)
															EndIf
																
														EndIf


													EndIf
												EndIf
											EndIf								
										EndIf									
									EndIf
								EndIf
							Next CZI2
	
						ElseIf (Obiekty_pociski(CZI1).kogo_uszkadza = 1) Then	''uszkadza gracza
							''hm..
							If (Obiekty_pociski(CZI1).Pozycja_point.x > Poz_samolotu.x1 - 14) Then
								If (Obiekty_pociski(CZI1).Pozycja_point.x < Poz_samolotu.x1 + 64) Then
									If (Obiekty_pociski(CZI1).Pozycja_point.y > Poz_samolotu.y1 - 14) Then
										If (Obiekty_pociski(CZI1).Pozycja_point.y < Poz_samolotu.y1 + 46) Then
											''trafilo gracza
											CZBL1 = 1
											If (Typ_kolizji = 1) Then
												CZBL1 = Sprawdz_zaawansowana_kolizje(Poz_samolotu.x1, Poz_samolotu.y1, 90, Obiekty_pociski(CZI1).Pozycja_point.x, Obiekty_pociski(CZI1).Pozycja_point.y, Obiekty_pociski(CZI1).Typ_obiektu, CZIL1, CZIL2)
												CZIL1 -= (Tablica_animacji(Obiekty_pociski(CZI1).Typ_obiektu).Wielkosc.x / 2)
												CZIL2 -= (Tablica_animacji(Obiekty_pociski(CZI1).Typ_obiektu).Wielkosc.y / 2)
											Else
												CZIL1 = Obiekty_pociski(CZI1).Pozycja_point.x
												CZIL2 = Obiekty_pociski(CZI1).Pozycja_point.y
											EndIf
											
											
											If (CZBL1 = 1) Then
												Obiekty_pociski(CZI1).Wyswietlac = 0
												
												''dodac maly wybuch
												Dodaj_wybuch(Obiekty_pociski(CZI1).Pozycja_point.x, Obiekty_pociski(CZI1).Pozycja_point.y, 70)
												
												Uszkodz_gracza(10)
											EndIf

										EndIf
									EndIf
								EndIf
							EndIf
						EndIf
							''End If czy gracza czy komputer uszkadza
						
					EndIf
				Next CZI1
				
				Czas_sprawdzania_kolizji = Czas_nowy
			EndIf
			
	
End Sub



''advance collisions checking sub
''per-pixel check
Function Sprawdz_zaawansowana_kolizje(ByVal Obiekt1_X As Integer, ByVal Obiekt1_Y As Integer, ByVal Obiekt1_typ As UByte, ByVal Obiekt2_X As integer, ByVal Obiekt2_Y As integer, ByVal Obiekt2_typ As UByte, ByRef MK_X As Integer, ByRef MK_Y As Integer) As UByte


Dim As Integer CZIL1, CZIL2, CZIL3, CZIL4, CZIL5
Dim As Integer Start1_X, Start1_Y, Start2_X, Start2_Y, Koniec1_X, Koniec1_Y, Koniec2_X, Koniec2_Y
Dim As Integer Curr1_X, Curr1_Y, Curr2_X, Curr2_Y, itt
Dim As UByte Robic_funkcje_kolizji


''preapering variables
''for X
CZIL1 = Obiekt2_X - Obiekt1_X
If (CZIL1 > 0) Then
	Start1_X = Tablica_animacji(Obiekt1_typ).Rect_klatki(1).x1 + CZIL1
	Start2_X = Tablica_animacji(Obiekt2_typ).Rect_klatki(1).x1
	CZIL2 = Obiekt2_X
Else	''CZIL =< 0
	Start1_X = Tablica_animacji(Obiekt1_typ).Rect_klatki(1).x1
	Start2_X = Tablica_animacji(Obiekt2_typ).Rect_klatki(1).x1 - CZIL1
	CZIL2 = Obiekt1_X
EndIf
	''WindowTitle(Str(obiekt1_x) & " .. " & obiekt2_x & " .. " & Str(CZIL1))

CZIL1 = (Obiekt2_X + Tablica_animacji(Obiekt2_typ).Wielkosc.x) - (Obiekt1_X + Tablica_animacji(Obiekt1_typ).Wielkosc.x)
If (CZIL1 > 0) Then
	Koniec1_X = Tablica_animacji(Obiekt1_typ).Rect_klatki(1).x2
	Koniec2_X = Tablica_animacji(Obiekt2_typ).Rect_klatki(1).x2 - CZIL1
	CZIL3 = Obiekt2_X + Tablica_animacji(Obiekt2_typ).Wielkosc.x
	''WindowTitle(">0")
Else
	''Koniec1_X = Tablica_animacji(Obiekt1_typ).Rect_klatki(1).x1 + CZIL1
	Koniec1_X = (Obiekt2_X + Tablica_animacji(Obiekt2_typ).Wielkosc.x) - Obiekt1_X + Tablica_animacji(Obiekt1_typ).Rect_klatki(1).x1 
	Koniec2_X = Tablica_animacji(Obiekt2_typ).Rect_klatki(1).x2
	CZIL3 = Obiekt1_X + Tablica_animacji(Obiekt1_typ).Wielkosc.x
	''WindowTitle("<=0")
EndIf


''for Y
CZIL1 = Obiekt2_Y - Obiekt1_Y
If (CZIL1 > 0) Then
	Start1_Y = Tablica_animacji(Obiekt1_typ).Rect_klatki(1).y1 + CZIL1
	Start2_Y = Tablica_animacji(Obiekt2_typ).Rect_klatki(1).y1
	CZIL4 = Obiekt2_Y
Else	''CZIL =< 0
	Start1_Y = Tablica_animacji(Obiekt1_typ).Rect_klatki(1).y1
	Start2_Y = Tablica_animacji(Obiekt2_typ).Rect_klatki(1).y1 - CZIL1
	CZIL4 = Obiekt1_Y
EndIf

CZIL1 = (Obiekt2_Y + Tablica_animacji(Obiekt2_typ).Wielkosc.y) - (Obiekt1_Y + Tablica_animacji(Obiekt1_typ).Wielkosc.y)
If (CZIL1 > 0) Then
	Koniec1_Y = Tablica_animacji(Obiekt1_typ).Rect_klatki(1).y2
	Koniec2_Y = Tablica_animacji(Obiekt2_typ).Rect_klatki(1).y2 - CZIL1
	CZIL5 = Obiekt2_Y + Tablica_animacji(Obiekt2_typ).Wielkosc.y
Else
	''Koniec1_Y = Tablica_animacji(Obiekt1_typ).Rect_klatki(1).y1 + CZIL1
	Koniec1_Y = (Obiekt2_Y + Tablica_animacji(Obiekt2_typ).Wielkosc.y) - Obiekt1_Y + Tablica_animacji(Obiekt1_typ).Rect_klatki(1).y1 
	Koniec2_Y = Tablica_animacji(Obiekt2_typ).Rect_klatki(1).y2
	CZIL5 = Obiekt1_Y + Tablica_animacji(Obiekt1_typ).Wielkosc.y
EndIf


/'
Start1_X += 1
Start1_Y += 1
Start2_X += 1
Start2_Y += 1
Koniec1_X -= 1
Koniec1_Y -= 1
Koniec2_X -= 1
Koniec2_Y -= 1
'/


Robic_funkcje_kolizji = 1
Curr1_X = Start1_X
Curr1_Y = Start1_Y
Curr2_X = Start2_X
Curr2_Y = Start2_Y
itt = 0




''Line (CZIL2, CZIL4) - (CZIL3, CZIL5), RGB(255,255,255),bf


''main loop for collision checking
While (Robic_funkcje_kolizji = 1)
	''If (Point(Curr1_X, Curr1_Y, Grafika_bmp) <> RGBA(255, 0, 255, 255)) And (Point(Curr2_X, Curr2_Y, Grafika_bmp) <> RGBA(255, 0, 255, 255)) Then
	''If (Point(Curr1_X, Curr1_Y, Grafika_bmp) <> 4294902015) And (Point(Curr2_X, Curr2_Y, Grafika_bmp) <> 4294902015) Then
	If (Tablica_kolizji(Curr1_X, Curr1_Y) = 1) And (Tablica_kolizji(Curr2_X, Curr2_Y) = 1) Then
		''collision
		MK_X = Curr1_X - Tablica_animacji(Obiekt1_typ).Rect_klatki(1).x1 + Obiekt1_X
		MK_Y = Curr1_Y - Tablica_animacji(Obiekt1_typ).Rect_klatki(1).y1 + Obiekt1_Y
		''Robic_funkcje_kolizji = 0
		''WindowTitle("collide -> " & MK_X & " : " & MK_Y & " ... itt: " & itt)
		Return 1	''there is a collision
	EndIf
	
	''itt += 1
	Curr1_X += 1
	If (Curr1_X >= Koniec1_X) Then
		Curr1_X = Start1_X
		Curr2_X = Start2_X
		Curr1_Y += 1
		If (Curr1_Y >= Koniec1_Y) Then
			''koniec sprawdzania
			''Robic_funkcje_kolizji = 0
			''WindowTitle("not collide")
			Return 0
		Else
			Curr2_Y += 1
		EndIf
	Else
		Curr2_X += 1
	EndIf

Wend


''WindowTitle("not collide")
Return 0	''no collision

	
End Function


''Enemies addind sub
Sub Procedura_dodawania_przeciwnikow()
	
	

			''zwiekszenie licznikow, increment counter's
			Licznik_wysp += 1
			Licznik_malych += 1
			Licznik_srednich += 1
			Licznik_duzych += 1


			''inne
			''wysepka, island's
			If (Licznik_wysp >= 40) Then
				CZI1 = Zwroc_pierwszy_wolny_morski()
				
				''Obiekty_morskie(CZI1).Pozycja_point.y = - 64
				''Obiekty_morskie(CZI1).Pozycja_point.x = Int(Rnd * Rozmieszczenie_tablica(Index_rozdzielczosci).Ilosc_blokow_64) * 64
				Obiekty_morskie(CZI1).Typ_obiektu = Int(Rnd * 3) + 50	''index ladu
				Obiekty_morskie(CZI1).Pozycja_point = Wybierz_pozycje_dla_wodnego(50)
				Obiekty_morskie(CZI1).Kierunek_ruchu.y = Szybkosc_wody
				Obiekty_morskie(CZI1).Kierunek_ruchu.x = 0
				Obiekty_morskie(CZI1).Wyswietlac = 1
				Obiekty_morskie(CZI1).nr_klatki = 1
				Obiekty_morskie(CZI1).kogo_uszkadza = 0
				Obiekty_morskie(CZI1).Energia_HP = 0
				Obiekty_morskie(CZI1).Wielkosc = Tablica_animacji(50).Wielkosc
	
				Licznik_wysp = 0			
			EndIf
			''male samoloty, small aircraft's
			If (Licznik_malych >= Zakres_malych) Then
				CZI1 = Zwroc_pierwszy_wolny_powietrzny()
				CZI2 = Int(Rnd * 7) + 1
				If (CZI2 < 6) Then
					''zwykle w dol, moving down -> normal
					Obiekty_powietrzne(CZI1).Pozycja_point.y = - 64
					Obiekty_powietrzne(CZI1).Pozycja_point.x = 32 + Int(Rnd * Rozmieszczenie_tablica(Index_rozdzielczosci).Ilosc_blokow_32) * 32
					Obiekty_powietrzne(CZI1).Typ_obiektu = CZI2	''index pierwszych samolotow
					Obiekty_powietrzne(CZI1).Kierunek_ruchu.y = 2 * Szybkosc_wody
					Obiekty_powietrzne(CZI1).Kierunek_ruchu.x = 0					
					Obiekty_powietrzne(CZI1).Wyswietlac = 1
					Obiekty_powietrzne(CZI1).nr_klatki = 1
					Obiekty_powietrzne(CZI1).kogo_uszkadza = 1
					CZI4 = 1
				ElseIf (CZI2 = 6) Then
					''kamikadze
					Obiekty_powietrzne(CZI1).Pozycja_point.y = - 64
					Obiekty_powietrzne(CZI1).Pozycja_point.x = 32 + Int(Rnd * Rozmieszczenie_tablica(Index_rozdzielczosci).Ilosc_blokow_32) * 32
					CZI3 = Poz_samolotu.x1 - Int(Obiekty_powietrzne(CZI1).Pozycja_point.x)
					If (CZI3 < -64) Then
						''skrecajacy w lewo, moving left
						Obiekty_powietrzne(CZI1).Typ_obiektu = 43
					ElseIf (CZI3 > 64) Then
						''skrecajacy w prawo, moving right
						Obiekty_powietrzne(CZI1).Typ_obiektu = 42
					Else
						''prosto w dol, simple down
						Obiekty_powietrzne(CZI1).Typ_obiektu = 41
					EndIf
					Obiekty_powietrzne(CZI1).Kierunek_ruchu.y = 2 * Szybkosc_wody
					Obiekty_powietrzne(CZI1).Kierunek_ruchu.x = (CZI3 / Rect_ekranu.y2) * 2
					Obiekty_powietrzne(CZI1).Wyswietlac = 1
					Obiekty_powietrzne(CZI1).nr_klatki = 1
					Obiekty_powietrzne(CZI1).kogo_uszkadza = 1
					CZI4 = 6				
				ElseIf (CZI2 = 7) Then
					''zwykly w gore - szybki, moving up -> fast
					Obiekty_powietrzne(CZI1).Pozycja_point.y = Rect_ekranu.y2 + 63
					Obiekty_powietrzne(CZI1).Pozycja_point.x = 32 + Int(Rnd * Rozmieszczenie_tablica(Index_rozdzielczosci).Ilosc_blokow_32) * 32
					Obiekty_powietrzne(CZI1).Typ_obiektu = 44	''index pierwszych samolotow
					Obiekty_powietrzne(CZI1).Kierunek_ruchu.y = -2 * Szybkosc_wody
					Obiekty_powietrzne(CZI1).Kierunek_ruchu.x = 0
					Obiekty_powietrzne(CZI1).Wyswietlac = 1
					Obiekty_powietrzne(CZI1).nr_klatki = 1
					Obiekty_powietrzne(CZI1).kogo_uszkadza = 1
					CZI4 = 7
				EndIf
				''wszystkie maja jedna wytrzymalosc, all them have the same HP
				Obiekty_powietrzne(CZI1).Energia_HP = Tablica_animacji(44).Energia_HP
				Obiekty_powietrzne(CZI1).Wielkosc = Tablica_animacji(44).Wielkosc
					
				Licznik_malych = 0
			EndIf
			''srednie samoloty, medium aircraft's
			If (Licznik_srednich >= Zakres_srednich) Then
				CZI1 = Zwroc_pierwszy_wolny_powietrzny()
				CZI2 = Int(Rnd * 2)	''sa dwa typy srednich, there are two type's
				
				If (CZI2 = 0) Then
					''wylatujacy od gory, moving from up to down
					CZI2 = 46
					Obiekty_powietrzne(CZI1).Pozycja_point.y = - 64
					Obiekty_powietrzne(CZI1).Kierunek_ruchu.y = 0.5 * Szybkosc_wody
				Else
					''wylatujacy od dolu - za naszym samolotem, moving from down to up
					CZI2 = 45
					Obiekty_powietrzne(CZI1).Pozycja_point.y = Rect_ekranu.y2 + 63
					Obiekty_powietrzne(CZI1).Kierunek_ruchu.y = -0.5 * Szybkosc_wody
				EndIf
				
				''wspolne dla obu rodzajow, same for them
				Obiekty_powietrzne(CZI1).Pozycja_point.x = 32 + Int(Rnd * Rozmieszczenie_tablica(Index_rozdzielczosci).Ilosc_blokow_64) * 64
				Obiekty_powietrzne(CZI1).Kierunek_ruchu.x = 0
				Obiekty_powietrzne(CZI1).Typ_obiektu = CZI2	''index pierwszych samolotow
				Obiekty_powietrzne(CZI1).Wyswietlac = 1
				Obiekty_powietrzne(CZI1).nr_klatki = 1
				Obiekty_powietrzne(CZI1).kogo_uszkadza = 1
				Obiekty_powietrzne(CZI1).Energia_HP = Tablica_animacji(CZI2).Energia_HP
				Obiekty_powietrzne(CZI1).Wielkosc = Tablica_animacji(CZI2).Wielkosc
				''Obiekty_powietrzne(CZI1).Czas_od_wystrzalu = 2
				
				Licznik_srednich = 0
			EndIf
			''duze pojazdy - lodzie i duzy samolot, big aricraft's / ship's
			If (Licznik_duzych >= Zakres_duzych) Then
				CZI2 = Int(Rnd * 3)
				If (CZI2 = 0) Then
					''duzy samolot - rowniez jako morski pojazd, normal
					CZI1 = Zwroc_pierwszy_wolny_powietrzny()
					Obiekty_powietrzne(CZI1).Pozycja_point.y = -64
					Obiekty_powietrzne(CZI1).Pozycja_point.x = 32 + Int(Rnd * Rozmieszczenie_tablica(Index_rozdzielczosci).Ilosc_blokow_128) * 128
					Obiekty_powietrzne(CZI1).Typ_obiektu = 47
					Obiekty_powietrzne(CZI1).Kierunek_ruchu.y = 0.5 * Szybkosc_wody
					Obiekty_powietrzne(CZI1).Kierunek_ruchu.x = 0
					Obiekty_powietrzne(CZI1).Wyswietlac = 1
					Obiekty_powietrzne(CZI1).nr_klatki = 1
					Obiekty_powietrzne(CZI1).kogo_uszkadza = 1
					Obiekty_powietrzne(CZI1).Energia_HP = Tablica_animacji(47).Energia_HP
					Obiekty_powietrzne(CZI1).Wielkosc = Tablica_animacji(47).Wielkosc
					''Obiekty_powietrzne(CZI1).Czas_od_wystrzalu = 2
				ElseIf (CZI2 = 1) Then
					''statek, ship
					CZI1 = Zwroc_pierwszy_wolny_morski()
					''Obiekty_morskie(CZI1).Pozycja_point.y = - 180
					''Obiekty_morskie(CZI1).Pozycja_point.x = 32 + Int(Rnd * Rozmieszczenie_tablica(Index_rozdzielczosci).Ilosc_blokow_128) * 128
					Obiekty_morskie(CZI1).Typ_obiektu = 58
					Obiekty_morskie(CZI1).Pozycja_point = Wybierz_pozycje_dla_wodnego(58)
					Obiekty_morskie(CZI1).Kierunek_ruchu.y = 1 * Szybkosc_wody
					Obiekty_morskie(CZI1).Kierunek_ruchu.x = 0
					Obiekty_morskie(CZI1).Wyswietlac = 1
					Obiekty_morskie(CZI1).nr_klatki = 1
					Obiekty_morskie(CZI1).kogo_uszkadza = 0
					Obiekty_morskie(CZI1).Energia_HP = Tablica_animacji(58).Energia_HP
					Obiekty_morskie(CZI1).Wielkosc = Tablica_animacji(58).Wielkosc
					''Obiekty_morskie(CZI1).Czas_od_wystrzalu = 2
				ElseIf (CZI2 = 2) Then
					''lodz podwodna - wynurzajca sie, submarine
					CZI1 = Zwroc_pierwszy_wolny_morski()
					''Obiekty_morskie(CZI1).Pozycja_point.y = - 48
					''Obiekty_morskie(CZI1).Pozycja_point.x = 32 + Int(Rnd * Rozmieszczenie_tablica(Index_rozdzielczosci).Ilosc_blokow_128) * 128
					Obiekty_morskie(CZI1).Typ_obiektu = 57
					Obiekty_morskie(CZI1).Pozycja_point = Wybierz_pozycje_dla_wodnego(57)
					Obiekty_morskie(CZI1).Kierunek_ruchu.y = 1 * Szybkosc_wody
					Obiekty_morskie(CZI1).Kierunek_ruchu.x = 0
					Obiekty_morskie(CZI1).Wyswietlac = 1
					Obiekty_morskie(CZI1).nr_klatki = 1
					Obiekty_morskie(CZI1).kogo_uszkadza = 0
					Obiekty_morskie(CZI1).Energia_HP = Tablica_animacji(57).Energia_HP
					Obiekty_morskie(CZI1).Wielkosc = Tablica_animacji(57).Wielkosc
					''Obiekty_morskie(CZI1).Czas_od_wystrzalu = 2
				EndIf
				
				Licznik_duzych = 0
			EndIf



End Sub



''read all animation data, and info for object's type
Sub Wczytaj_Dane_Animacji()
	
	Dim As Integer WPL
	Dim As String CZSL1, CZSL2, CZSL3, CZSL4
	Dim As Integer CZIL1, CZIL2, CZIL3, CZIL4, CZIL5, CZIL6, CZIL7, CZIL8
	
	
	WPL = FreeFile
	
	Open "anim_data.dat" For Input As #WP
		Input #WP, CZSL1	''comment line
		
		While Not Eof(WP)
			Input #WP, CZSL1	''number of animation
			Input #WP, CZSL2	''number of frames
			CZIL1 = CInt(CZSL1)
			CZIL2 = CInt(CZSL2)
			Tablica_animacji(CZIL1).Ilosc_klatek = CUByte(CZIL2)
			''read animation data
			For CZIL3 = 1 To CZIL2
				''Input #WP, CZSL1, CZSL2, CZSL3, CZSL4
				Input #WP, CZIL4, CZIL5, CZIL6, CZIL7
				Tablica_animacji(CZIL1).Rect_klatki(CZIL3) = Podstaw_Rect_moj(CZIL4, CZIL5, CZIL6, CZIL7)
			Next CZIL3
			
			Input #WP, CZSL1	''HP for this object
			Tablica_animacji(CZIL1).Energia_HP = CInt(CZSL1)
			''Input #WP, CZSL1, CZSL2	''width & heigth of object
			Input #WP, CZIL4, CZIL5
			Tablica_animacji(CZIL1).Wielkosc = Podstaw_Point_2D(CZIL4, CZIL5)
			
		Wend
		
	Close #WP
	
	''ready
		
End Sub


''choose position for sea object
Function Wybierz_pozycje_dla_wodnego(ByVal typ_obiektu As UByte) As Point_2DS
	Dim As Integer CZIL1, CZIL2, CZIL3, CZIL4
	Dim As UByte nie_koliduje
	Dim As Point_2DS wynik_funkcji
	
	''Obiekty_morskie(CZI1).Pozycja_point.y = - 64
	''Obiekty_morskie(CZI1).Pozycja_point.x = Int(Rnd * Rozmieszczenie_tablica(Index_rozdzielczosci).Ilosc_blokow_64) * 64
	
	Select Case As Const typ_obiektu
		Case 50
			CZIL2 = -64
		Case 57
			CZIL2 = -98
		Case 58
			CZIL2 = -180
	End Select

	''losowanie wstepne
	nie_koliduje = 0
	While (nie_koliduje = 0)
		CZIL1 = 32 + Int(Rnd * Rozmieszczenie_tablica(Index_rozdzielczosci).Ilosc_blokow_64) * 64
		nie_koliduje = 1
		
		For CZIL3 = 1 To 100
			If (Obiekty_morskie(CZIL3).Wyswietlac = 1) Then
				''is colliding
				If (Obiekty_morskie(CZIL3).Pozycja_point.x > CZIL1 - Obiekty_morskie(CZIL3).Wielkosc.x) Then
					If (Obiekty_morskie(CZIL3).Pozycja_point.x < CZIL1 + 64) Then
						If (Obiekty_morskie(CZIL3).Pozycja_point.y > CZIL2 - Obiekty_morskie(CZIL3).Wielkosc.y) Then
							If (Obiekty_morskie(CZIL3).Pozycja_point.y < 0) Then
								''nastapila kolizja
								nie_koliduje = 0
								Exit For
							EndIf
						EndIf
					EndIf
				EndIf
				''
			EndIf
		Next CZIL3
		
	Wend
	
	wynik_funkcji.y = CZIL2
	wynik_funkcji.x = CZIL1
	
	Return wynik_funkcji
	
End Function

